/******************************************************************************/
/* Configuration pour l'archivage des diffrents lments du fichier source   */
/******************************************************************************/
// !CONFIG!=/L/* /R/* /W"* Nom : "
// Dfinition du systme       !CONFIG!=/V1!EMULATEUR CPC!
// Dfinition du sous systme  !CONFIG!=/V2!PC-CPC!
// Dfinition du sous ensemble !CONFIG!=/V3!Accessoires!
// Dfinition du module        !CONFIG!=/V4!Aide!
/******************************************************************************/

/********************************************************* !NAME! **************
* !./FLE!
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\Fichiers
********************************************************** !0! *****************
* ------------------------------------------------------------------------------
*          SYSTEME         |      SOUS SYSTEME       |      SOUS ENSEMBLE
* ------------------------------------------------------------------------------
*  EMULATEUR CPC           | PC-CPC                  | Accessoires
* ------------------------------------------------------------------------------
*  Fichier     : AIDE.C                | Version : 0.1an
* ------------------------------------------------------------------------------
*  Date        : 10/05/2007            | Auteur  : L.DEPLANQUE
* ------------------------------------------------------------------------------
*  Description : Affiche le menu d'aide
*
* ------------------------------------------------------------------------------
*  Historique  :
*           Date           |         Auteur          |       Description
* ------------------------------------------------------------------------------
*  10/05/2007              | L.DEPLANQUE             | creation
* ------------------------------------------------------------------------------
********************************************************** !END! **************/


#include  <windows.h>

#include  "types.h"
#include  "Plateform.h"


static HDC dc;


static void Affiche( HDC DeviceContext, int x, int y, char * Msg )
{
    TextOut( DeviceContext, x, y, Msg, strlen( Msg ) );
}


static void AfficheAide( void )
{
    Affiche( dc, 0x02, 0x26, "F1  = Aide" );
    Affiche( dc, 0x02, 0x34, "F2  = Turbo ON/OFF" );
    Affiche( dc, 0x02, 0x42, "F3  = Bp Multiface" );
    Affiche( dc, 0x02, 0x50, "F4  = Lecture SNA" );
    Affiche( dc, 0x02, 0x5E, "F5  = Sauvegarde SNA" );
    Affiche( dc, 0x02, 0x6C, "F6  = Debug ON/OFF" );
    Affiche( dc, 0x02, 0x7A, "F7  = Lecture DSK" );
    Affiche( dc, 0x02, 0x88, "F8  = Reset" );
    Affiche( dc, 0x02, 0x96, "F9  = Lecture Cassette" );
    Affiche( dc, 0x02, 0xB2, "F11 = Ecriture Cassette" );
    Affiche( dc, 0x02, 0xC0, "F12 = Lecture/ecriture lecteur PC" );

    Affiche( dc, 0xB2, 0x34, "Shift+F2  = Sauve BMP" );
    Affiche( dc, 0xB2, 0x42, "Shift+F3  = Taille fenetre" );
    Affiche( dc, 0xB2, 0x50, "Shift+F4  = Mono/Couleur" );
    Affiche( dc, 0xB2, 0x5E, "Shift+F5  = Sauvegarde YM" );
    Affiche( dc, 0xB2, 0x96, "Shift+F9  = Positionnement Cassette" );
    Affiche( dc, 0xB2, 0xB2, "Shift+F11 = Sauvegarde AVI" );
}


static long FAR PASCAL AideWndProc( HWND hWnd
                                  , UINT iMessage
                                  , WPARAM wParam
                                  , LPARAM lParam
                                  )
{
    switch( iMessage )
        {
        case WM_PAINT :
            AfficheAide();
            break;

        case WM_DESTROY :
            PostQuitMessage( 0 );
            break;

        case WM_KEYDOWN :
        case WM_KEYUP :
            PostMessage( hWnd, WM_CLOSE, 0, 0L );
            break;
         }
    return( DefWindowProc( hWnd, iMessage, wParam, lParam ) );
}


void Aide( HWND hParent )
{
    WNDCLASS wndClass;
    HWND hWnd;
    MSG msg;
    HFONT f;

    //
    // Enregistrement de la classe de la fentre
    //
    memset( &wndClass, 0, sizeof( WNDCLASS ) );
    wndClass.style          = CS_HREDRAW | CS_VREDRAW;
    wndClass.lpfnWndProc    = AideWndProc;
    wndClass.hbrBackground  = CreateSolidBrush( BK_COLOR );
    wndClass.lpszMenuName   = "AideMenu";
    wndClass.lpszClassName  = "Aide";
    if ( RegisterClass( &wndClass ) )
        {
        int x = 35, y = 35;
        WINDOWPLACEMENT Pos;

        if ( GetWindowPlacement( hParent, &Pos ) )
            {
            x = Pos.rcNormalPosition.left + 10;
            y = Pos.rcNormalPosition.top + 30;
            }
        //
        // Cration de la fentre
        //
        hWnd = CreateWindow("Aide"
                           , "Aide"
                           , WS_POPUPWINDOW
                           , x, y, 370, 240
                           , hParent
                           , NULL
                           , NULL
                           , NULL
                           );
        ShowWindow( hWnd, SW_SHOW );
        UpdateWindow( hWnd );
        f = CreateFont( 12, 0, 0, 0, FW_DONTCARE, 0, 0, 0
                      , OEM_CHARSET
                      , OUT_DEFAULT_PRECIS
                      , CLIP_DEFAULT_PRECIS
                      , DEFAULT_QUALITY
                      , FIXED_PITCH | FF_DONTCARE,NULL
                      );
        if ( f )
            {
            dc = GetDC( hWnd );
            SelectObject( dc, f );
            SetTextColor( dc, TEXT_COLOR );
            SetBkColor( dc, BK_COLOR );
            AfficheAide();
            while( GetMessage( &msg, NULL, 0,0 ) )
                {
                TranslateMessage( &msg );
                DispatchMessage( &msg );
                }
            DeleteObject( f );
            }
        UnregisterClass( "Aide", NULL );
        }
}

