/******************************************************************************/
/* Configuration pour l'archivage des diffrents lments du fichier source   */
/******************************************************************************/
// !CONFIG!=/L/* /R/* /W"* Nom : "
// Dfinition du systme       !CONFIG!=/V1!EMULATEUR CPC!
// Dfinition du sous systme  !CONFIG!=/V2!PC-CPC!
// Dfinition du sous ensemble !CONFIG!=/V3!Chips!
// Dfinition du module        !CONFIG!=/V4!CRTC 6845!
/******************************************************************************/

/********************************************************* !NAME! **************
* !./FLE!
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\Fichiers
********************************************************** !0! *****************
* ------------------------------------------------------------------------------
*  Fichier     : CRTC.H                | Version : 0.1an
* ------------------------------------------------------------------------------
*  Date        : 05/11/2002            | Auteur  : L.DEPLANQUE
* ------------------------------------------------------------------------------
*  Description : Dfinitions pour le module CRTC.C
*
* ------------------------------------------------------------------------------
*  Historique  :
*           Date           |         Auteur          |       Description
* ------------------------------------------------------------------------------
*  05/11/2002              | L.DEPLANQUE             | creation
* ------------------------------------------------------------------------------
*  13/11/2002              | L.DEPLANQUE             | Changement du type de
*                          |                         | la variable TabAdrCrtc : 
*                          |                         | passage en USHORT, pour
*                          |                         | optimiser le memset
*                          |                         | dans CalcAdrEcrCPC()
* ------------------------------------------------------------------------------
*  08/02/2006              | L.DEPLANQUE             | Version 0.1ak :
*                          |                         | Ajout variables XStart,
*                          |                         | XEnd, et fonction      
*                          |                         | CalcCRTCLine
* ------------------------------------------------------------------------------
*  06/12/2006              | L.DEPLANQUE             | Version 0.1am :
*                          |                         | Variable "VBL" remplace
*                          |                         | par "VSync" et supprime
*                          |                         | du module PPI
* ------------------------------------------------------------------------------
*  01/03/2007              | L.DEPLANQUE             | Version 0.1an :
*                          |                         | Rcriture complte de
*                          |                         | la fonction principale
*                          |                         | du CRTC, prise en compte
*                          |                         | d'un cycle (1 mot vido)
*                          |                         | au lieu d'une ligne HBL
* ------------------------------------------------------------------------------
********************************************************** !END! **************/


#ifndef CRTC_H
#define CRTC_H


extern int RegsCRTC[ 32 ];

extern int RegCRTCSel;

extern int CntHSync;

extern int VSync;

extern int DoResync;


int ReadCRTC( int adr );

void WriteCRTC( int adr, int val );

void CycleCRTC( int NbCycles );

void ResetCRTC( void );


#endif
