/******************************************************************************/
/* Configuration pour l'archivage des diffrents lments du fichier source   */
/******************************************************************************/
// !CONFIG!=/L/* /R/* /W"* Nom : "
// Dfinition du systme       !CONFIG!=/V1!EMULATEUR CPC!
// Dfinition du sous systme  !CONFIG!=/V2!PC-CPC!
// Dfinition du sous ensemble !CONFIG!=/V3!Accessoires!
// Dfinition du module        !CONFIG!=/V4!Gestion Configuration!
/******************************************************************************/

/********************************************************* !NAME! **************
* !./FLE!
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\Fichiers
********************************************************** !0! *****************
* ------------------------------------------------------------------------------
*          SYSTEME         |      SOUS SYSTEME       |      SOUS ENSEMBLE
* ------------------------------------------------------------------------------
*  EMULATEUR CPC           | PC-CPC                  | Accessoires
* ------------------------------------------------------------------------------
*  Fichier     : CONFIG.C              | Version : 0.1an
* ------------------------------------------------------------------------------
*  Date        : 05/11/2002            | Auteur  : L.DEPLANQUE
* ------------------------------------------------------------------------------
*  Description : Dcodage du fichier de configuration
*
* ------------------------------------------------------------------------------
*  Historique  :
*           Date           |         Auteur          |       Description
* ------------------------------------------------------------------------------
*  05/11/2002              | L.DEPLANQUE             | creation
* ------------------------------------------------------------------------------
*  06/01/2003              | L.DEPLANQUE             | Version 0.1t : Gestion
*                          |                         | nouvelles variables :
*                          |                         | localisation des roms
* ------------------------------------------------------------------------------
*  09/01/2003              | L.DEPLANQUE             | Version 0.1u : Gestion
*                          |                         | nouvelles variables :
*                          |                         | touches joystick
* ------------------------------------------------------------------------------
*  03/02/2003              | L.DEPLANQUE             | Version 0.1v : Gestion
*                          |                         | nouvelles variables :
*                          |                         | localisation fichiers
*                          |                         | DSK, SNA, TAP
* ------------------------------------------------------------------------------
*  06/05/2003              | L.DEPLANQUE             | Version 0.1w :
*                          |                         | Initialisation des
*                          |                         | valeurs par dfaut pour
*                          |                         | les variables contenant
*                          |                         | les scan-codes des
*                          |                         | touches mulant le
*                          |                         | joystick
* ------------------------------------------------------------------------------
*  22/01/2004              | L.DEPLANQUE             | Version 0.1x : Gestion
*                          |                         | nouvelle variable :
*                          |                         | localisation rpertoire
*                          |                         | emulation disque
* ------------------------------------------------------------------------------
*  03/02/2004              | L.DEPLANQUE             | Version 0.1y : 
*                          |                         | Suppression des
*                          |                         | fonctions de lecture
*                          |                         | des variables de type
*                          |                         | paramtres, et passage
*                          |                         | de ces variables en
*                          |                         | variables globales.
* ------------------------------------------------------------------------------
*  04/08/2004              | L.DEPLANQUE             | Version 0.1ab : 
*                          |                         | Prise en compte de
*                          |                         | 16 roms d'extensions.
* ------------------------------------------------------------------------------
*  05/10/2004              | L.DEPLANQUE             | Version 0.1ac : 
*                          |                         | Prise en compte de
*                          |                         | l'mulation de disque
*                          |                         | avec la commande
*                          |                         | avec la commande
*                          |                         | #NEW_DISC ON ou OFF
* ------------------------------------------------------------------------------
*  11/12/2004              | L.DEPLANQUE             | Version 0.1ae :
*                          |                         | Ajout d'un flag pour
*                          |                         | utilisation de la rom pack
*                          |                         | avec la commande
*                          |                         | #USE_ROM_PACK ON ou OFF
* ------------------------------------------------------------------------------
*  02/06/2005              | L.DEPLANQUE             | Version 0.1ag :
*                          |                         | Ajout de flags divers
*                          |                         | (sons cassette,
*                          |                         | mulation iprimante...)
* ------------------------------------------------------------------------------
*  30/11/2005              | L.DEPLANQUE             | Version 0.1ah :
*                          |                         | Suppression flag
*                          |                         | utilisation rom pack
*                          |                         | (prise comme rom externe)
*                          |                         | Ajout variable rpertoire
*                          |                         | pour sauvegarde .AVI
* ------------------------------------------------------------------------------
*  08/02/2006              | L.DEPLANQUE             | Version 0.1ak :
*                          |                         | Suppression flag
*                          |                         | inutiles (maintenant
*                          |                         | calculs avec les
*                          |                         | registres du CRTC
* ------------------------------------------------------------------------------
*  20/07/2006              | L.DEPLANQUE             | Version 0.1al :
*                          |                         | Suppression flag
*                          |                         | #SOUND, ajout flag
*                          |                         | #DOUBLE_LINES
*                          |                         | #BORDERLESS
*                          |                         | #RESO_X
*                          |                         | #RESO_Y
*                          |                         | #DIR_YM_FILE
* ------------------------------------------------------------------------------
*  06/09/2006              | L.DEPLANQUE             | Version 0.1am :
*                          |                         | Suppression flag
*                          |                         | #LIGNE_DIRECT
*                          |                         | ajout flag
*                          |                         | #USE_512KO
* ------------------------------------------------------------------------------
*  23/02/2007              | L.DEPLANQUE             | Version 0.1an :
*                          |                         | Ajout Flags
*                          |                         | #USE_PC_VBL,
*                          |                         | #JOY_XXX_KEY
*                          |                         | Supperssion Flag
*                          |                         | #NEW_DISC
* ------------------------------------------------------------------------------
********************************************************** !END! **************/


#include  <stdlib.h>
#include  <string.h>
#include  <stdio.h>

#include  "types.h"
#include  "PlateForm.h"
#include  "config.h"
#include  "Log.h"


#define     MODULENAME      "Config"


#define     CONFIG_NAME     "CONFIG.CPC"


enum FctJoy { JOY_UP = 0
            , JOY_DOWN
            , JOY_LEFT
            , JOY_RIGHT
            , JOY_FIRE1
            , JOY_FIRE2
            , JOY_FIRE3
            , JOY_FIRE4
            , JOY_FIRE5
            , JOY_FIRE6
            , JOY_FIRE7
            , JOY_FIRE8
            , JOY_FIRE9
            , JOY_FIREA
            };


/********************************************************* !NAME! **************
* Nom : FrameSkip
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Frquence de rafraichissement cran
*
********************************************************** !0! ****************/
int FrameSkip = 0;


/********************************************************* !NAME! **************
* Nom : SmallScreen
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Petit cran ou non
*
********************************************************** !0! ****************/
int SmallScreen = 0;


/********************************************************* !NAME! **************
* Nom : DoubleLines
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Indique s'il faut doubler les lignes en mode grand cran ou non
*
********************************************************** !0! ****************/
int DoubleLines = 0;


/********************************************************* !NAME! **************
* Nom : BorderLess
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Indique si la fentre doit tre sans bordure ou avec bordure
*
********************************************************** !0! ****************/
#ifdef USE_DIRECTX
int BorderLess = 0;
#endif


/********************************************************* !NAME! **************
* Nom : TailleFenX
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Indique la taille de la fentre en X
*
********************************************************** !0! ****************/
int TailleFenX = 0;


/********************************************************* !NAME! **************
* Nom : TailleFenY
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Indique la taille de la fentre en Y
*
********************************************************** !0! ****************/
int TailleFenY = 0;


/********************************************************* !NAME! **************
* Nom : Multiface
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Multiface active ou non
*
********************************************************** !0! ****************/
#ifdef USE_MULTIFACE
int Multiface = 1;
#endif


/********************************************************* !NAME! **************
* Nom : LogLevel
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Niveau de logging
*
********************************************************** !0! ****************/
#ifdef USE_LOG
int LogLevel = 3;
#endif


/********************************************************* !NAME! **************
* Nom : LocRomInf
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Localisation du fichier contenant la rom infrieure du CPC
*
********************************************************** !0! ****************/
char LocRomInf[ LEN_PATH ];


/********************************************************* !NAME! **************
* Nom : LocRomExt
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Localisation des fichier contenant les roms d'extensions
*
********************************************************** !0! ****************/
char LocRomExt[ MAX_ROM_EXT ][ LEN_PATH ];


/********************************************************* !NAME! **************
* Nom : LocRomMulti
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Localisation du fichier contenant la rom de l'interface
*               Multiface II
*
********************************************************** !0! ****************/
#ifdef USE_MULTIFACE
char LocRomMulti[ LEN_PATH ];
#endif


/********************************************************* !NAME! **************
* Nom : DirSnap
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Localisation du rpertoire contenant les fichiers snapshots
*
********************************************************** !0! ****************/
char DirSnap[ LEN_PATH ];


/********************************************************* !NAME! **************
* Nom : DirTape
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Localisation du rpertoire contenant les fichiers cassettes
*
********************************************************** !0! ****************/
char DirTape[ LEN_PATH ];


/********************************************************* !NAME! **************
* Nom : DirDisc
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Localisation du rpertoire contenant les fichiers disquettes
*
********************************************************** !0! ****************/
char DirDisc[ LEN_PATH ];


/********************************************************* !NAME! **************
* Nom : DirEmuDisc
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Localisation du rpertoire servant  l'mulation disque
*
********************************************************** !0! ****************/
#ifdef USE_NEWDISC
char DirEmuDisc[ LEN_PATH ];
#endif


/********************************************************* !NAME! **************
* Nom : DirAviFile
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Localisation du rpertoire servant  sauver les fichiers AVI
*
********************************************************** !0! ****************/
#ifdef USE_SAVE_AVI
char DirAviFile[ LEN_PATH ];
#endif


/********************************************************* !NAME! **************
* Nom : DirYMFile
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Localisation du rpertoire servant  sauver les fichiers YM
*
********************************************************** !0! ****************/
#ifdef USE_SAVE_YM
char DirYMFile[ LEN_PATH ];
#endif


/********************************************************* !NAME! **************
* Nom : NewDiscOn
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Activation/dsactivation du module mulation disque
*
********************************************************** !0! ****************/
#ifdef USE_NEWDISC
int NewDiscOn = 0;
#endif


/********************************************************* !NAME! **************
* Nom : UseSoundCas
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Activation/dsactivation des sons sur cassette
*
********************************************************** !0! ****************/
#ifdef USE_TAPE
int UseSoundCas = 0;
#endif


/********************************************************* !NAME! **************
* Nom : UsePrinter
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Activation/dsactivation de l'mulation de l'imprimante
*
********************************************************** !0! ****************/
#ifdef USE_PRINTER
int UsePrinter = 0;
#endif


/********************************************************* !NAME! **************
* Nom : FreqWavOut
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Frquence d'chantillonage des fichiers .WAV en sortie
*
********************************************************** !0! ****************/
#ifdef USE_TAPE
int FreqWavOut = 11025;
#endif


/********************************************************* !NAME! **************
* Nom : Use512Ko
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Utilisation de 512Ko de mmoire supplmentaire
*
********************************************************** !0! ****************/
int Use512Ko = 0;


/********************************************************* !NAME! **************
* Nom : UsePcVBL
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Utilisation de la "VBL" du PC Hote
*
********************************************************** !0! ****************/
int UsePcVBL = 0;


/********************************************************* !NAME! **************
* Nom : StTabRedirectJoy
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Tableau de redirection des fonctions du joystick.
*               (Valeurs par dfaut)
*
********************************************************** !0! ****************/
stToucheClav StTabRedirectJoy[ 16 ] = 
    {
        { 0xFE, 0x09 },           // UP
        { 0xFD, 0x09 },           // DOWN
        { 0xFB, 0x09 },           // LEFT
        { 0xF7, 0x09 },           // RIGHT
        { 0xEF, 0x09 },           // FIRE 1
        { 0xDF, 0x09 },           // FIRE 2
        { 0xBF, 0x09 },           // FIRE 3
        { 0xFF, 0x0F },           // FIRE 4
        { 0xFF, 0x0F },           // FIRE 5
        { 0xFF, 0x0F },           // FIRE 6
        { 0xFF, 0x0F },           // FIRE 7
        { 0xFF, 0x0F },           // FIRE 8
        { 0xFF, 0x0F },           // FIRE 9
        { 0xFF, 0x0F },           // FIRE 10
    };


/********************************************************* !NAME! **************
* Nom : AffecteToucheJoy
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Affecte une touche clavier  une fonction du joystick
*
* Rsultat    : /
*
* Variables globales modifies : StTabRedirectJoy
*
********************************************************** !0! ****************/
static void AffecteToucheJoy( int NumFctJoy, char * ToucheJoy )
{
    static char * TabDefKey[ 80 ] =
        {
        "KEY_UP",
        "KEY_RIGHT",
        "KEY_DOWN",
        "KEY_F9",
        "KEY_F6",
        "KEY_F3",
        "KEY_ENTER",
        "KEY_UNDEF",
        "KEY_LEFT",
        "KEY_COPY",
        "KEY_F7",
        "KEY_F8",
        "KEY_F5",
        "KEY_F1",
        "KEY_F2",
        "KEY_F0",
        "KEY_CLR",
        "KEY_[",
        "KEY_RETURN",
        "KEY_]",
        "KEY_F4",
        "KEY_SHIFT",
        "KEY_\\",
        "KEY_CTRL",
        "KEY_",
        "KEY_=",
        "KEY_@",
        "KEY_P",
        "KEY_+",
        "KEY_*",
        "KEY_?",
        "KEY_>",
        "KEY_0",
        "KEY_9",
        "KEY_O",
        "KEY_I",
        "KEY_L",
        "KEY_K",
        "KEY_M",
        "KEY_<",
        "KEY_8",
        "KEY_7",
        "KEY_U",
        "KEY_Y",
        "KEY_H",
        "KEY_J",
        "KEY_N",
        "KEY_SPC",
        "KEY_6",
        "KEY_5",
        "KEY_R",
        "KEY_T",
        "KEY_G",
        "KEY_F",
        "KEY_B",
        "KEY_V",
        "KEY_4",
        "KEY_3",
        "KEY_E",
        "KEY_Z",
        "KEY_S",
        "KEY_D",
        "KEY_C",
        "KEY_X",
        "KEY_2",
        "KEY_1",
        "KEY_ESC",
        "KEY_Q",
        "KEY_TAB",
        "KEY_A",
        "KEY_CAPS",
        "KEY_W",
        "JOY_UP",
        "JOY_DOWN",
        "JOY_LEFT",
        "JOY_RIGHT",
        "JOY_FIRE1",
        "JOY_FIRE2",
        "JOY_FIRE3",
        "KEY_DEL",
        };

    BOOL Trouve = FALSE;
    // Recherche la touche clavier correspondante
    for ( int i = 0; i < 80; i++ )
        if ( ! strcmp( TabDefKey[ i ], ToucheJoy ) )
            {
            StTabRedirectJoy[ NumFctJoy ].Port = ( BYTE )( ~ ( 1 << ( i & 7 ) ) );
            StTabRedirectJoy[ NumFctJoy ].Ligne = ( BYTE )( i >> 3 );
            Trouve = TRUE;
            break;
            }

    if ( ! Trouve )
        {
        sprintf( MsgLog, "Touche %s inconnue", ToucheJoy );
#ifdef USE_LOG
        Log( MODULENAME, MsgLog, LOG_WARNING );
#endif
        Erreur( MsgLog );
        }
}


/********************************************************* !NAME! **************
* Nom : GetVal
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Retourne une valeur numrique contenue dans une chaine
*
* Rsultat    : La valeur contenue dans la chaine
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
static int GetVal( char * Chaine )
{
    int val = 0;

    while ( * Chaine == ' ' )
        Chaine++;

    if ( Chaine[ 0 ] == 'O' && Chaine[ 1 ] == 'N' ) 
        val = 1;
    else
        val = atoi( Chaine );

    return( val );
}


/********************************************************* !NAME! **************
* Nom : GetChaine
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Retourne une valeur alphanumrique contenue dans une chaine
*
* Rsultat    : La valeur contenue dans la chaine
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
static char * GetChaine( char * Chaine )
{
    char * p;

    while ( * Chaine == ' ' )
        Chaine++;

    p = Chaine;
    while( * p && * p >= ' ' )
        p++;

    * p = 0;
    return( Chaine );
}


static void GetRomExt( char * Chaine )
{
    int NumRom = atoi( Chaine );
    if ( NumRom < MAX_ROM_EXT && NumRom >= 0 )
        strcpy( LocRomExt[ NumRom ], GetChaine( &Chaine[ 2 ] ) );
}


/********************************************************* !NAME! **************
* Nom : ReadConfig
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Lecture du fichier config. et affectation des variables
*               concernes
*
* Rsultat    : TRUE si lecture fichier config. OK, FALSE sinon
*
* Variables globales modifies : FrameSkip, SmallScreen, 
*                                Multiface, LogLevel, DoubleLines, BorderLess
*                                LocRomInf, LocRomExt, LocRomMulti,
*                                JoyLeft, JoyRight, JoyUp, JoyDown, JoyFire1,
*                                JoyFire2, DirSnap, DirTape, DirDisc
*
********************************************************** !0! ****************/
BOOL ReadConfig( void )
{
    static char Buffer[ 80 ];

    FILE * fp = fopen( CONFIG_NAME, "rt" );
    memset( LocRomExt, 0, sizeof( LocRomExt ) );
    if ( fp )
        {
        while( fgets( Buffer, sizeof( Buffer ), fp ) )
            {
            if ( Buffer[ 0 ] == '#' )
                {
                if ( ! strncmp( Buffer, "#FRAMESKIP", 10 ) )
                    FrameSkip = GetVal( &Buffer[ 12 ] );

                if ( ! strncmp( Buffer, "#SMALL_SCREEN", 13 ) )
                    SmallScreen = GetVal( &Buffer[ 15 ] );

                if ( ! strncmp( Buffer, "#DOUBLE_LINES", 13 ) )
                    DoubleLines = GetVal( &Buffer[ 15 ] );

#ifdef USE_DIRECTX
                if ( ! strncmp( Buffer, "#BORDERLESS", 11 ) )
                    BorderLess = GetVal( &Buffer[ 13 ] );

                if ( ! strncmp( Buffer, "#RESO_X", 7 ) )
                    TailleFenX = GetVal( &Buffer[ 9 ] );

                if ( ! strncmp( Buffer, "#RESO_Y", 7 ) )
                    TailleFenY = GetVal( &Buffer[ 9 ] );
#endif
#ifdef USE_LOG
                if ( ! strncmp( Buffer, "#LOG_LEVEL", 10 ) )
                    LogLevel = GetVal( &Buffer[ 12 ] );
#endif
                if ( ! strncmp( Buffer, "#ROM_INF", 8 ) )
                    strcpy( LocRomInf, GetChaine( &Buffer[ 10 ] ) );

                if ( ! strncmp( Buffer, "#ROM_EXT", 8 ) )
                    GetRomExt( &Buffer[ 8 ] );

#ifdef USE_MULTIFACE
                if ( ! strncmp( Buffer, "#MULTIFACE", 10 ) )
                    Multiface = GetVal( &Buffer[ 12 ] );

                if ( ! strncmp( Buffer, "#ROM_MULTI", 10 ) )
                    strcpy( LocRomMulti, GetChaine( &Buffer[ 12 ] ) );
#endif
                if ( ! strncmp( Buffer, "#DIR_SNAP", 9 ) )
                    strcpy( DirSnap, GetChaine( &Buffer[ 11 ] ) );

                if ( ! strncmp( Buffer, "#DIR_TAPE", 9 ) )
                    strcpy( DirTape, GetChaine( &Buffer[ 11 ] ) );

                if ( ! strncmp( Buffer, "#DIR_DISC", 9 ) )
                    strcpy( DirDisc, GetChaine( &Buffer[ 11 ] ) );

#ifdef USE_NEWDISC
                if ( ! strncmp( Buffer, "#DIR_EMU_DISC", 13 ) )
                    strcpy( DirEmuDisc, GetChaine( &Buffer[ 15 ] ) );
#endif

#ifdef USE_PRINTER
                if ( ! strncmp( Buffer, "#USE_PRINTER", 12 ) )
                    UsePrinter = GetVal( &Buffer[ 14 ] );
#endif
#ifdef USE_TAPE
                if ( ! strncmp( Buffer, "#USE_SOUND_CAS", 14 ) )
                    UseSoundCas = GetVal( &Buffer[ 16 ] );

                if ( ! strncmp( Buffer, "#FREQ_WAV_OUT", 13 ) )
                    FreqWavOut = GetVal( &Buffer[ 15 ] );
#endif
#ifdef USE_SAVE_AVI
                if ( ! strncmp( Buffer, "#DIR_AVI_FILE", 13 ) )
                    strcpy( DirAviFile, GetChaine( &Buffer[ 15 ] ) );
#endif
#ifdef USE_SAVE_YM
                if ( ! strncmp( Buffer, "#DIR_YM_FILE", 13 ) )
                    strcpy( DirYMFile, GetChaine( &Buffer[ 15 ] ) );
#endif
                if ( ! strncmp( Buffer, "#USE_512KO", 10 ) )
                    Use512Ko = GetVal( &Buffer[ 12 ] );

                if ( ! strncmp( Buffer, "#USE_PC_VBL", 11 ) )
                    UsePcVBL = GetVal( &Buffer[ 13 ] );

                if ( ! strncmp( Buffer, "#JOY_UP_KEY", 11 ) )
                    AffecteToucheJoy( JOY_UP, GetChaine( &Buffer[ 13 ] ) );

                if ( ! strncmp( Buffer, "#JOY_DOWN_KEY", 13 ) )
                    AffecteToucheJoy( JOY_DOWN, GetChaine( &Buffer[ 15 ] ) );

                if ( ! strncmp( Buffer, "#JOY_LEFT_KEY", 13 ) )
                    AffecteToucheJoy( JOY_LEFT, GetChaine( &Buffer[ 15 ] ) );

                if ( ! strncmp( Buffer, "#JOY_RIGHT_KEY", 14 ) )
                    AffecteToucheJoy( JOY_RIGHT, GetChaine( &Buffer[ 16 ] ) );

                if ( ! strncmp( Buffer, "#JOY_FIRE1_KEY", 14 ) )
                    AffecteToucheJoy( JOY_FIRE1, GetChaine( &Buffer[ 16 ] ) );

                if ( ! strncmp( Buffer, "#JOY_FIRE2_KEY", 14 ) )
                    AffecteToucheJoy( JOY_FIRE2, GetChaine( &Buffer[ 16 ] ) );

                if ( ! strncmp( Buffer, "#JOY_FIRE3_KEY", 14 ) )
                    AffecteToucheJoy( JOY_FIRE3, GetChaine( &Buffer[ 16 ] ) );

                if ( ! strncmp( Buffer, "#JOY_FIRE4_KEY", 14 ) )
                    AffecteToucheJoy( JOY_FIRE4, GetChaine( &Buffer[ 16 ] ) );

                if ( ! strncmp( Buffer, "#JOY_FIRE5_KEY", 14 ) )
                    AffecteToucheJoy( JOY_FIRE5, GetChaine( &Buffer[ 16 ] ) );

                if ( ! strncmp( Buffer, "#JOY_FIRE6_KEY", 14 ) )
                    AffecteToucheJoy( JOY_FIRE6, GetChaine( &Buffer[ 16 ] ) );

                if ( ! strncmp( Buffer, "#JOY_FIRE7_KEY", 14 ) )
                    AffecteToucheJoy( JOY_FIRE7, GetChaine( &Buffer[ 16 ] ) );

                if ( ! strncmp( Buffer, "#JOY_FIRE8_KEY", 14 ) )
                    AffecteToucheJoy( JOY_FIRE8, GetChaine( &Buffer[ 16 ] ) );

                if ( ! strncmp( Buffer, "#JOY_FIRE9_KEY", 14 ) )
                    AffecteToucheJoy( JOY_FIRE9, GetChaine( &Buffer[ 16 ] ) );

                if ( ! strncmp( Buffer, "#JOY_FIREA_KEY", 14 ) )
                    AffecteToucheJoy( JOY_FIREA, GetChaine( &Buffer[ 16 ] ) );
                }
            }
        fclose( fp );
        return( TRUE );
        }
    return( FALSE );
}
