/******************************************************************************/
/* Configuration pour l'archivage des diffrents lments du fichier source   */
/******************************************************************************/
// !CONFIG!=/L/* /R/* /W"* Nom : "
// Dfinition du systme       !CONFIG!=/V1!EMULATEUR CPC!
// Dfinition du sous systme  !CONFIG!=/V2!PC-CPC!
// Dfinition du sous ensemble !CONFIG!=/V3!Accessoires!
// Dfinition du module        !CONFIG!=/V4!Conversion Bitmap!
/******************************************************************************/

/********************************************************* !NAME! **************
* !./FLE!
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\Fichiers
********************************************************** !0! *****************
* ------------------------------------------------------------------------------
*          SYSTEME         |      SOUS SYSTEME       |      SOUS ENSEMBLE
* ------------------------------------------------------------------------------
*  EMULATEUR CPC           | PC-CPC                  | Accessoires
* ------------------------------------------------------------------------------
*  Fichier     : CONVERSION.CPP        | Version : 0.1ak
* ------------------------------------------------------------------------------
*  Date        : 20/02/2006            | Auteur  : L.DEPLANQUE
* ------------------------------------------------------------------------------
*  Description : Conversion Bitmap vers cran du CPC
*
* ------------------------------------------------------------------------------
*  Historique  :
*           Date           |         Auteur          |       Description
* ------------------------------------------------------------------------------
*  20/02/2006              | L.DEPLANQUE             | creation
* ------------------------------------------------------------------------------
********************************************************** !END! **************/


#include  <windows.h>

#include  "Types.h"
#include  "Plateform.h"
#include  "VGA.h"
#include  "Z80.h"


#ifdef USE_ROM_PACK

#define     TAILLE_X    640

#define     TAILLE_Y    400

#define     LUM_CPC_0       0x00
#define     LUM_CPC_1       0x66
#define     LUM_CPC_2       0xF0

#define     SEUIL_LUM_1     85
#define     SEUIL_LUM_2     170


enum { COMP_R, COMP_V, COMP_B };


/********************************************************* !NAME! **************
* Nom : StRVB
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Structures
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Structure de la couleur d'un pixel en 32 bits
*
********************************************************** !0! ****************/
typedef struct
    {
    BYTE b, v, r, a;
    } StRVB;


/********************************************************* !NAME! **************
* Nom : corr
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Correction de l'erreur relative de couleurs pour chaque
*               composante
*
********************************************************** !0! ****************/
static int corr[ 4 ];


/********************************************************* !NAME! **************
* Nom : Coul
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Compteur des couleurs CPC utilises dans l'image
*
********************************************************** !0! ****************/
static int Coul[ 27 ];


/********************************************************* !NAME! **************
* Nom : RgbCPC
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Couleurs du cpc
*
********************************************************** !0! ****************/
static StRVB RgbCPC[ 27 ] =
    {
        { LUM_CPC_0, LUM_CPC_0, LUM_CPC_0, LUM_CPC_0 },
        { LUM_CPC_1, LUM_CPC_0, LUM_CPC_0, LUM_CPC_0 },
        { LUM_CPC_2, LUM_CPC_0, LUM_CPC_0, LUM_CPC_0 },
        { LUM_CPC_0, LUM_CPC_0, LUM_CPC_1, LUM_CPC_0 },
        { LUM_CPC_1, LUM_CPC_0, LUM_CPC_1, LUM_CPC_0 },
        { LUM_CPC_2, LUM_CPC_0, LUM_CPC_1, LUM_CPC_0 },
        { LUM_CPC_0, LUM_CPC_0, LUM_CPC_2, LUM_CPC_0 },
        { LUM_CPC_1, LUM_CPC_0, LUM_CPC_2, LUM_CPC_0 },
        { LUM_CPC_2, LUM_CPC_0, LUM_CPC_2, LUM_CPC_0 },
        { LUM_CPC_0, LUM_CPC_1, LUM_CPC_0, LUM_CPC_0 },
        { LUM_CPC_1, LUM_CPC_1, LUM_CPC_0, LUM_CPC_0 },
        { LUM_CPC_2, LUM_CPC_1, LUM_CPC_0, LUM_CPC_0 },
        { LUM_CPC_0, LUM_CPC_1, LUM_CPC_1, LUM_CPC_0 },
        { LUM_CPC_1, LUM_CPC_1, LUM_CPC_1, LUM_CPC_0 },
        { LUM_CPC_2, LUM_CPC_1, LUM_CPC_1, LUM_CPC_0 },
        { LUM_CPC_0, LUM_CPC_1, LUM_CPC_2, LUM_CPC_0 },
        { LUM_CPC_1, LUM_CPC_1, LUM_CPC_2, LUM_CPC_0 },
        { LUM_CPC_2, LUM_CPC_1, LUM_CPC_2, LUM_CPC_0 },
        { LUM_CPC_0, LUM_CPC_2, LUM_CPC_0, LUM_CPC_0 },
        { LUM_CPC_1, LUM_CPC_2, LUM_CPC_0, LUM_CPC_0 },
        { LUM_CPC_2, LUM_CPC_2, LUM_CPC_0, LUM_CPC_0 },
        { LUM_CPC_0, LUM_CPC_2, LUM_CPC_1, LUM_CPC_0 },
        { LUM_CPC_1, LUM_CPC_2, LUM_CPC_1, LUM_CPC_0 },
        { LUM_CPC_2, LUM_CPC_2, LUM_CPC_1, LUM_CPC_0 },
        { LUM_CPC_0, LUM_CPC_2, LUM_CPC_2, LUM_CPC_0 },
        { LUM_CPC_1, LUM_CPC_2, LUM_CPC_2, LUM_CPC_0 },
        { LUM_CPC_2, LUM_CPC_2, LUM_CPC_2, LUM_CPC_0 }
    };


/********************************************************* !NAME! **************
* Nom : CalcDiff
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Calcule la diffrence de couleur entre le pixel rel et le
*               pixel converti dans la palette du CPC
*
* Rsultat    : /
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
static void CalcDiff( int diff, int Methode, int Pct, int Matrice )
{
    int k;

    if ( Matrice == 3 )
        Pct = Pct / 3;

    switch( Methode )
        {
        case 1 :
            k = Pct ? 16000 / Pct : 100000;
            corr[ 0 ] = ( diff * 70 ) / k;
            corr[ 1 ] = ( diff * 30 ) / k;
            corr[ 2 ] = ( diff * 50 ) / k;
            corr[ 3 ] = ( diff * 10 ) / k;
            break;

        case 2 :
            k = Pct ? 7500 / Pct : 100000;
            corr[ 0 ] = ( diff * 40 ) / k;
            corr[ 1 ] = ( diff * 20 ) / k;
            corr[ 2 ] = ( diff * 10 ) / k;
            corr[ 3 ] = ( diff * 5 ) / k;
            break;

        case 3 :
            k = Pct ? 15000 / Pct : 100000;
            corr[ 0 ] = ( diff * 80 ) / k;
            corr[ 1 ] = ( diff * 20 ) / k;
            corr[ 2 ] = ( diff * 40 ) / k;
            corr[ 3 ] = ( diff * 10 ) / k;
            break;
        }
}


/********************************************************* !NAME! **************
* Nom : AddPixel
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Ajoute une correction d'erreur  une composante (r,v,b)
*               d'un pixel
*
* Rsultat    : /
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
static void AddPixel( StRVB * Bitmap, int x, int y, int corr, int comp )
{
    int vcomp;

    if ( x < TAILLE_X && y < TAILLE_Y && x >= 0 )
        {
        StRVB * p = &Bitmap[ x + TAILLE_X * y ];
        BYTE * c = &p->r;
        switch( comp )
            {
            case COMP_V :
                c = &p->v;
                break;

            case COMP_B :
                c = &p->b;
                break;
            }
        vcomp = max( 0, min( * c + corr, 255 ) );
        * c = ( BYTE )vcomp;
        }
}


/********************************************************* !NAME! **************
* Nom : AddPixelCor
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Ajoute le tramage  un pixel donn
*
* Rsultat    : /
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
static void AddPixelCor( StRVB * Bitmap
                       , int x
                       , int y
                       , int comp
                       , int Tx
                       , int Matrice
                       , int Methode
                       )
{
    if ( Methode )
        {
        switch( Matrice )
            {
            case 2 :
                AddPixel( Bitmap, x + Tx, y, corr[ 0 ], comp );

                AddPixel( Bitmap, x - Tx, y + 2, corr[ 1 ], comp );
                AddPixel( Bitmap, x, y + 2, corr[ 2 ], comp );
                AddPixel( Bitmap, x + Tx, y + 2, corr[ 3 ], comp );
                break;

            case 3 :
                AddPixel( Bitmap, x + Tx, y, corr[ 0 ], comp );
                AddPixel( Bitmap, x + 2 * Tx, y, corr[ 2 ], comp );

                AddPixel( Bitmap, x - 2 * Tx, y + 2, corr[ 1 ], comp );
                AddPixel( Bitmap, x - Tx, y + 2, corr[ 2 ], comp );
                AddPixel( Bitmap, x, y + 2, corr[ 0 ], comp );
                AddPixel( Bitmap, x + Tx, y + 2, corr[ 2 ], comp );
                AddPixel( Bitmap, x + 2 * Tx, y + 2, corr[ 1 ], comp );

                AddPixel( Bitmap, x - Tx, y + 2 * 2, corr[ 1 ], comp );
                AddPixel( Bitmap, x, y + 2 * 2, corr[ 2 ], comp );
                AddPixel( Bitmap, x + Tx, y + 2 * 2, corr[ 1 ], comp );
                break;
            }
        }
}


/********************************************************* !NAME! **************
* Nom : Convert
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Effectue la conversion Bitmap -> cran cpc
*
* Rsultat    : /
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
static void Convert( int Methode
                   , int Pct
                   , int Matrice
                   , int Mode
                   , StRVB * Bitmap
                   , int CMax[ 16 ]
                   , int Bloque[ 16 ]
                   )
{
    int i, x, y, Tx = 4 >> Mode, MaxCol = 16;
    int Dist = 0, OldDist = 0x7FFFF;
    StRVB s, Choix1, * pix1, p2;

    switch( Mode )
        {
        case 0 :
            MaxCol = 16;
            break;

        case 1 :
            MaxCol = 4;
            break;

        case 2 :
            MaxCol = 2;
            break;
        }

    memset( Coul, 0, sizeof( Coul ) );
    for ( y = 0; y < TAILLE_Y; y += 2 )
        for ( x = 0; x < TAILLE_X; x += Tx )
            {
            // Lecture de la couleur du point au coordonnes (x,y)
            StRVB * p1 = &Bitmap[ x + TAILLE_X * y ];
            p1->a = 0;

            // Modifie composante Rouge

            //p2.r = ( BYTE )( ( p1->r / 86 ) * 127 );
            p2.r = ( BYTE )( p1->r > SEUIL_LUM_2 ? LUM_CPC_2 : p1->r > SEUIL_LUM_1 ? LUM_CPC_1 : LUM_CPC_0 );
            CalcDiff( p1->r - p2.r, Methode, Pct, Matrice );
            p1->r = p2.r;
            AddPixelCor( Bitmap, x, y, COMP_R, Tx, Matrice, Methode );

            // Modifie composante Verte
            p2.v = ( BYTE )( p1->v > SEUIL_LUM_2 ? LUM_CPC_2 : p1->v > SEUIL_LUM_1 ? LUM_CPC_1 : LUM_CPC_0 );
            //p2.v = ( BYTE )( ( p1->v / 86 ) * 127 );
            CalcDiff( p1->v - p2.v, Methode, Pct, Matrice );
            p1->v = p2.v;
            AddPixelCor( Bitmap, x, y, COMP_V, Tx, Matrice, Methode );

            // Modifie composante Bleue
            //p2.b = ( BYTE )( ( p1->b / 86 ) * 127 );
            p2.b = ( BYTE )( p1->b > SEUIL_LUM_2 ? LUM_CPC_2 : p1->b > SEUIL_LUM_1 ? LUM_CPC_1 : LUM_CPC_0 );
            CalcDiff( p1->b - p2.b, Methode, Pct, Matrice );
            p1->b = p2.b;
            AddPixelCor( Bitmap, x, y, COMP_B, Tx, Matrice, Methode );
            s = Bitmap[ x + TAILLE_X * y ];
            for ( i = 0; i < 27; i++ )
                if ( * ( int * )&s == * ( int * )&RgbCPC[ i ] )
                    Coul[ i ]++;
            }
    for ( i = 0; i < 16; i++ )
        if ( ! Bloque[ i ] )
            CMax[ i ] = 0;

    for ( x = 0; x < MaxCol; x++ )
        if ( Bloque[ x ] )
            Coul[ CMax[ x ] ] = 0;

    for ( x = 0; x < MaxCol; x++ )
        {
        int valMax = 0;
        if ( ! Bloque[ x ] )
            {
            for ( i = 0; i < 27; i++ )
                {
                if ( valMax < Coul[ i ] )
                    {
                    valMax = Coul[ i ];
                    CMax[ x ] = i;
                    }
                }
            Coul[ CMax[ x ] ] = 0;
            }
        }
    for ( y = 0; y < TAILLE_Y; y += 2 )
        for ( x = 0; x < TAILLE_X; x += Tx )
            {
            pix1 = &Bitmap[ x + TAILLE_X * y ];
            Choix1 = * pix1;
            OldDist = 0x7FFFF;
            for ( i = 0; i < MaxCol; i++ )
                {
                s = RgbCPC[ CMax[ i ] ];

                Dist = abs( s.r - pix1->r ) * 299
                     + abs( s.v - pix1->v ) * 587
                     + abs( s.b - pix1->b ) * 114;
                if ( Dist < OldDist )
                    {
                    OldDist = Dist;
                    Choix1 = s;
                    Choix1.a = ( BYTE )i;   // Numro de couleur dans la
                                            // Palette du CPC (0  16)
                    }
                }
            * pix1 = Choix1;
            for ( i = 0; i < Tx; i++ )
                {
                Bitmap[ i + x + TAILLE_X * y ] =
                Bitmap[ TAILLE_X + i + x + TAILLE_X * y ] =
                Bitmap[ x + TAILLE_X * y ];
                }
            }
}


/********************************************************* !NAME! **************
* Nom : AjusteContraste
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Ajuste le contraste de l'image
*
* Rsultat    : /
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
static void AjusteContraste( StRVB * Bitmap, int r, int v, int b )
{
    int x, y;

    for ( y = 0; y < TAILLE_Y; y++ )
        for ( x = 0; x < TAILLE_X; x++ )
            {
            StRVB * p1 = &Bitmap[ x + TAILLE_X * y ];
            p1->r = ( BYTE )max( 0, min( p1->r * r / 100, 255 ) );
            p1->v = ( BYTE )max( 0, min( p1->v * v / 100, 255 ) );
            p1->b = ( BYTE )max( 0, min( p1->b * b / 100, 255 ) );
            }
}


/********************************************************* !NAME! **************
* Nom : CreeBitmapCPC
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Cre un bitmap au format d'cran du CPC
*
* Rsultat    : /
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
static void CreeBitmapCPC( StRVB * Bitmap
                         , int Mode
                         , int DeplX
                         , int DeplY
                         , BOOL Transp
                         )
{
    BYTE Pix0, Pix1, Pix2, Pix3, Pix4, Pix5, Pix6, Pix7;
    int x, y, l, Oct = 0, pos = 0;
    int NbLig = 200, NbCol = 80;
    int Memo = DecodeurAdresse;

    WriteVGA( 0x8C | Mode );
    for ( y = 0; y < NbLig; y++ )
        {
        pos = 0xC000 + ( y >> 3 ) * NbCol + ( y & 7 ) * 0x800;
        l = TAILLE_X * ( y - DeplY ) * 2 - DeplX;
        for ( x = 0; x < NbCol; x++ )
            {
            if ( l >= 0 && x - ( DeplX >> 3 ) >= 0 )
                {
                //
                // Conversion pixels en fonction du mode CPC
                //
                Pix0 = Bitmap[ l ].a;
                switch( Mode )
                    {
                    case 0 :
                        Pix1 = Bitmap[ 4 + l ].a;
                        Oct = ( ( Pix0 & 1 ) << 7 ) +
                              ( ( Pix0 & 2 ) << 2 ) +
                              ( ( Pix0 & 4 ) << 3 ) +
                              ( ( Pix0 & 8 ) >> 2 ) +
                              ( ( Pix1 & 1 ) << 6 ) +
                              ( ( Pix1 & 2 ) << 1 ) +
                              ( ( Pix1 & 4 ) << 2 ) +
                              ( ( Pix1 & 8 ) >> 3 );
                        break;

                    case 1 :
                        Pix1 = Bitmap[ 2 + l ].a;
                        Pix2 = Bitmap[ 4 + l ].a;
                        Pix3 = Bitmap[ 6 + l ].a;
                        Oct = ( ( Pix0 & 1 ) << 7 ) +
                              ( ( Pix0 & 2 ) << 2 ) +
                              ( ( Pix1 & 1 ) << 6 ) +
                              ( ( Pix1 & 2 ) << 1 ) +
                              ( ( Pix2 & 1 ) << 5 ) +
                              ( Pix2 & 2 ) +
                              ( ( Pix3 & 1 ) << 4 ) +
                              ( ( Pix3 & 2 ) >> 1 );
                        break;

                    case 2 :
                        Pix1 = Bitmap[ 1 + l ].a;
                        Pix2 = Bitmap[ 2 + l ].a;
                        Pix3 = Bitmap[ 3 + l ].a;
                        Pix4 = Bitmap[ 4 + l ].a;
                        Pix5 = Bitmap[ 5 + l ].a;
                        Pix6 = Bitmap[ 6 + l ].a;
                        Pix7 = Bitmap[ 7 + l ].a;
                        Oct = ( Pix0 << 7 ) +
                              ( Pix1 << 6 ) +
                              ( Pix2 << 5 ) +
                              ( Pix3 << 4 ) +
                              ( Pix4 << 3 ) +
                              ( Pix5 << 2 ) +
                              ( Pix6 << 1 ) +
                              Pix7;
                        break;
                    }
                BYTE Result = ( BYTE )Oct;
                if ( Transp )
                    {
                    BYTE Old = Peek8Ext( ( USHORT )pos );
                    switch( Mode )
                        {
                        case 0 :
                            Pix0 = ( BYTE )( Old & 0xAA );
                            Pix1 = ( BYTE )( Old & 0x55 );
                            if ( ! ( Result & 0xAA ) )
                                Result |= Pix0;
                            if ( ! ( Result & 0x55 ) )
                                Result |= Pix1;
                            break;

                        case 1 :
                            Pix0 = ( BYTE )( Old & 0x88 );
                            Pix1 = ( BYTE )( Old & 0x44 );
                            Pix2 = ( BYTE )( Old & 0x22 );
                            Pix3 = ( BYTE )( Old & 0x11 );
                            if ( ! ( Result & 0x88 ) )
                                Result |= Pix0;
                            if ( ! ( Result & 0x44 ) )
                                Result |= Pix1;
                            if ( ! ( Result & 0x22 ) )
                                Result |= Pix2;
                            if ( ! ( Result & 0x11 ) )
                                Result |= Pix3;
                            break;

                        case 2 :
                            Result |= Old;
                            break;
                        }
                    }
                Poke8Ext( ( USHORT )( pos ), Result );
                }
            pos++;
            l += 8;
            }
        }
    WriteVGA( Memo | Mode );
}


/********************************************************* !NAME! **************
* Nom : SetInk
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Excute la commade basic "INK"
*
* Rsultat    : /
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
static void SetInk( BYTE NumInk, BYTE Col1, BYTE Col2 )
{
    USHORT SauvAF, SauvBC, SauvDE, SauvHL, SauvSP, SauvPC;

    SauvAF = RegAF;
    SauvBC = RegBC;
    SauvDE = RegDE;
    SauvHL = RegHL;
    SauvSP = RegSP;
    SauvPC = RegPC;
    RegPC = 0xBC32;
    RegA = NumInk;
    RegB = Col1;
    RegC = Col2;
    do
        {
        ExecInstZ80();
        }
    while( RegSP <= SauvSP );           // Attendre le "RET"
    RegSP = SauvSP;
    RegPC = SauvPC;
    RegAF = SauvAF;
    RegBC = SauvBC;
    RegDE = SauvDE;
    RegHL = SauvHL;
}


static HDC DcBitmap = NULL, DcTmp = NULL;
static HBITMAP bm = NULL;
static int * MemBitmapCPC;
static BITMAPINFO pbmiCPC;


/********************************************************* !NAME! **************
* Nom : ConvertBitmap
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Excution de la conversion avec les paramtres dsirs
*
* Rsultat    : 0 si ok, sinon code d'erreur
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
int ConvertBitmap( char * Nom, char * argv )
{
    static BYTE ConvColVGA[ 27 ] = 
        {
        0x14, 0x04, 0x15, 0x1C, 0x18, 0x1D, 0x0C, 0x05, 0x0D,
        0x16, 0x06, 0x17, 0x1E, 0x00, 0x1F, 0x0E, 0x07, 0x0F,
        0x12, 0x02, 0x13, 0x1A, 0x19, 0x1B, 0x0A, 0x03, 0x0B
        };
    HANDLE Bitmap;
    int Palette[ 16 ], Bloque[ 16 ];
    int i, j;
    int Trame = 0, r = 100, v = 100, b = 100, pct = 100;
    int DeplX = 0, DeplY = 0;
    int mat = 2;
    BOOL LockPal = FALSE, Transp = FALSE;
    int p;
    char * arg = argv;

    do
        {
        arg = strchr( arg, '-' );
        if ( arg )
            {
            arg++;
            switch( toupper( * arg++ ) )
                {
                case 'R' :  // Composante rouge
                    r =atoi( arg );
                    break;

                case 'V' : // Composante verte
                    v =atoi( arg );
                    break;

                case 'B' :  // Composante bleue
                    b = atoi( arg );
                    break;

                case 'L' :  // Bloquer la palette
                    LockPal = TRUE;

                case 'D' : // Dplacement (x ou y)
                    p = toupper( * arg );
                    if ( p == 'X' )
                        DeplX = atoi( ++arg );
                    else
                        if ( p == 'Y' )
                            DeplY = atoi( ++arg );
                    break;

                case 'P' :  // Pourcentage tramage
                    pct = atoi( arg );
                    break;

                case 'T' :  // Type Trame
                    Trame = atoi( arg );
                    break;

                case 'X' : // Type de matrice (2 ou 3)
                    mat = atoi( arg );
                    break;

                case 'A' : // Transparent
                    Transp = TRUE;
                    break;
                }
            }
        }
    while( arg );

    Bitmap = LoadImage( 0, Nom, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE );
    if ( Bitmap )
        {
        GetDIBits( DcTmp
                 , ( HBITMAP )Bitmap
                 , 0
                 , TAILLE_Y
                 , MemBitmapCPC
                 , &pbmiCPC
                 , DIB_RGB_COLORS
                 );
        if ( r != 100 || v != 100 || b != 100 )
            AjusteContraste( ( StRVB * )MemBitmapCPC, r, v, b );

        if ( LockPal )
            {
            memset( Bloque, 1, sizeof( Bloque ) );
            // Rcup couleurs...
            for ( i = 0; i < 16; i++ )
                for ( j = 0; j < 27; j++ )
                    if ( TabInk[ i ] == ( ConvColVGA[ j ] & 0x1F ) )
                        Palette[ i ] = j;
            }
        else
            memset( Bloque, 0, sizeof( Bloque ) );

        Convert( Trame
               , pct
               , mat
               , LastMode
               , ( StRVB * )MemBitmapCPC
               , Palette
               , Bloque
               );
        if ( ! LockPal )
            for ( i = 0; i < 16; i++ )
                SetInk( ( BYTE )i
                      , ( BYTE )Palette[ i ]
                      , ( BYTE )Palette[ i ]
                      );

        CreeBitmapCPC( ( StRVB * )MemBitmapCPC
                     , LastMode
                     , DeplX
                     , DeplY
                     , Transp
                     );
        DeleteObject( Bitmap );
        }
    return( 0 );
}


int InitConversion( void )
{
    int Ret = 0;

    pbmiCPC.bmiHeader.biSize = sizeof( BITMAPINFOHEADER );
    pbmiCPC.bmiHeader.biWidth = TAILLE_X;
    pbmiCPC.bmiHeader.biHeight = -TAILLE_Y;
    pbmiCPC.bmiHeader.biPlanes = 1;
    pbmiCPC.bmiHeader.biBitCount = 32;
    pbmiCPC.bmiHeader.biCompression = BI_RGB;
    pbmiCPC.bmiHeader.biSizeImage = 0;
    pbmiCPC.bmiHeader.biXPelsPerMeter = 0;
    pbmiCPC.bmiHeader.biYPelsPerMeter = 0;
    pbmiCPC.bmiHeader.biClrUsed =0;
    pbmiCPC.bmiHeader.biClrImportant = 0;
    bm = CreateDIBSection( DeviceContext
                         , &pbmiCPC
                         , DIB_RGB_COLORS
                         , ( void ** )&MemBitmapCPC
                         , NULL
                         , 0
                         );
    if ( bm )
        {
        DcBitmap = CreateCompatibleDC( DeviceContext );
        if ( DcBitmap )
            {
            SelectObject( DcBitmap, bm );
            SetStretchBltMode( DcBitmap, COLORONCOLOR );
            SetStretchBltMode( DeviceContext, COLORONCOLOR );
            DcTmp = CreateCompatibleDC( DeviceContext );
            if ( ! DcTmp )
                Ret = 1;
            }
        else
            Ret = 2;
        }
    else
        Ret = 3;

    return( Ret );
}


void EndConversion( void )
{
    if ( DcTmp )
        DeleteDC( DcTmp );

    if ( DcBitmap )
        DeleteDC( DcBitmap );

    if ( bm )
        DeleteObject( bm );
}

#endif