/******************************************************************************/
/* Configuration pour l'archivage des diffrents lments du fichier source   */
/******************************************************************************/
// !CONFIG!=/L/* /R/* /W"* Nom : "
// Dfinition du systme       !CONFIG!=/V1!EMULATEUR CPC!
// Dfinition du sous systme  !CONFIG!=/V2!PC-CPC!
// Dfinition du sous ensemble !CONFIG!=/V3!Noyau!
// Dfinition du module        !CONFIG!=/V4!Main!
/******************************************************************************/

/********************************************************* !NAME! **************
* !./FLE!
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\Fichiers
********************************************************** !0! *****************
* ------------------------------------------------------------------------------
*          SYSTEME         |      SOUS SYSTEME       |      SOUS ENSEMBLE
* ------------------------------------------------------------------------------
*  EMULATEUR CPC           | PC-CPC                  | Noyau
* ------------------------------------------------------------------------------
*  Fichier     : MAIN.C                | Version : 0.1an
* ------------------------------------------------------------------------------
*  Date        : 05/11/2002            | Auteur  : L.DEPLANQUE
* ------------------------------------------------------------------------------
*  Description : Programme principal
*
* ------------------------------------------------------------------------------
*  Historique  :
*           Date           |         Auteur          |       Description
* ------------------------------------------------------------------------------
*  05/11/2002              | L.DEPLANQUE             | Cration
* ------------------------------------------------------------------------------
*  07/11/2002              | L.DEPLANQUE             | Ajout gestion lecture et
*                          |                         | criture cassette :
*                          |                         | fonctions WriteCas() et
*                          |                         | ReadCas() appeles 
*                          |                         | chaque Hsync.
* ------------------------------------------------------------------------------
*  03/12/2002              | L.DEPLANQUE             | Prise en compte de la
*                          |                         | directive USE_DEBUG
*                          |                         | Optimisation de
*                          |                         | l'affichage et
*                          |                         | l'archivage des messages
*                          |                         | d'erreurs
* ------------------------------------------------------------------------------
*  06/01/2003              | L.DEPLANQUE             | Version 0.1t :
*                          |                         | Suppression d'un Warning
* ------------------------------------------------------------------------------
*  02/02/2004              | L.DEPLANQUE             | Version 0.1x :
*                          |                         | Modification de la
*                          |                         | frquence d'appel des
*                          |                         | fonctions lecture et
*                          |                         | critures cassettes,
*                          |                         | ajout d'une constante
*                          |                         | pour cette frquence.
* ------------------------------------------------------------------------------
*  30/03/2004              | L.DEPLANQUE             | Version 0.1z :
*                          |                         | Utilisation de la
*                          |                         | variable CptInstr en
*                          |                         | locale (suppression de
*                          |                         | la variable globale),
*                          |                         | les fonctions Z80
*                          |                         | retournent le nbre de
*                          |                         | cycles excuts.
* ------------------------------------------------------------------------------
*  30/09/2004              | L.DEPLANQUE             | Version 0.1ac :
*                          |                         | Prise en compte des
*                          |                         | arguments passs par
*                          |                         | la ligne de commande.
* ------------------------------------------------------------------------------
*  18/03/2005              | L.DEPLANQUE             | Version 0.1af :
*                          |                         | Optimisation temps cpu
*                          |                         | par fonction Sleep(1)
* ------------------------------------------------------------------------------
*  30/11/2005              | L.DEPLANQUE             | Version 0.1ah :
*                          |                         | Gestion sauvegarde des
*                          |                         | trames en fichier .AVI
* ------------------------------------------------------------------------------
*  08/12/2005              | L.DEPLANQUE             | Version 0.1ai :
*                          |                         | Correction d'un bugg
*                          |                         | (rgression) lors de la
*                          |                         | fin du programme : plus
*                          |                         | de sauvegarde du fichier
*                          |                         | DSK si modifi.
* ------------------------------------------------------------------------------
*  09/01/2006              | L.DEPLANQUE             | Version 0.1aj :
*                          |                         | Inhibition du mode turbo
*                          |                         | lors de la sauvegarde
*                          |                         | d'un fichier AVI.
* ------------------------------------------------------------------------------
*  20/02/2006              | L.DEPLANQUE             | Version 0.1ak :
*                          |                         | Suppression compteurs
*                          |                         | Timing (utiliss dans
*                          |                         | le module CRTC)
*                          |                         | Correction d'un bugg
*                          |                         | dans l'interprteur de
*                          |                         | ligne de commandes
* ------------------------------------------------------------------------------
*  20/07/2006              | L.DEPLANQUE             | Version 0.1al :
*                          |                         | Gestion sauvegarde des
*                          |                         | sons en fichier .YM
* ------------------------------------------------------------------------------
*  04/08/2006              | L.DEPLANQUE             | Version 0.1am :
*                          |                         | Gestion envoi commandes
*                          |                         | ou fichier au CPC mul.
* ------------------------------------------------------------------------------
*  20/02/2007              | L.DEPLANQUE             | Version 0.1an :
*                          |                         | Correction du "frameskip"
*                          |                         | qui passait au moins 1
*                          |                         | image, mme quand il
*                          |                         | tait rgl  zro.
*                          |                         | Nouvelle gestion du cycle
*                          |                         | du CRTC.
* ------------------------------------------------------------------------------
********************************************************** !END! **************/


#include  <windows.h>
#include  <ddraw.h>
#include  <stdio.h>

#include  "types.h"
#include  "plateform.h"
#include  "z80.h"
#include  "vga.h"
#include  "ppi.h"
#include  "upd.h"
#ifdef USE_MULTIFACE
#include  "multiface.h"
#endif
#include  "AY8912.h"
#include  "Sound.h"
#include  "Config.h"
#include  "crtc.h"
#include  "Log.h"
#ifdef USE_PRINTER
#include  "Printer.h"
#endif
#ifdef USE_DESASM
#include  "desasm.h"
#endif
#include  "snapshot.h"
#ifdef USE_SAVE_AVI
#include  "WriteAvi.h"
#endif
#ifdef USE_SAVE_YM
#include  "WriteYM.h"
#endif
#ifdef USE_ROM_PACK
#include  "Conversion.h"
#endif


#define     MODULENAME      "Main"


#ifdef USE_DIRECTX
extern LPDIRECTDRAW lpDD;
#endif


/********************************************************* !NAME! **************
* Nom : StConvAscii
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Structures
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Structure conversion codes ASCII->scancodes CPC
*
********************************************************** !0! ****************/
#ifdef USE_SENDKEYS
typedef struct
    {
    BYTE Ligne;
    BYTE Port;
    BYTE Shift;
    } StConvAscii;
#endif


/********************************************************* !NAME! **************
* Nom : finMain
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\\/FLE!, ligne : !./LN!
*
* Description : Fin du programme
*
********************************************************** !0! ****************/
int finMain = 0;


/********************************************************* !NAME! **************
* Nom : TabAscii
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Tableau de conversion codes ASCII->scancodes CPC
*
********************************************************** !0! ****************/
#ifdef USE_SENDKEYS
static StConvAscii TabAscii[ 256 ] =
    {
    0x0F, 0xFF, 0x00,                   //  00
    0x0F, 0xFF, 0x00,                   //  01
    0x0F, 0xFF, 0x00,                   //  02
    0x0F, 0xFF, 0x00,                   //  03
    0x0F, 0xFF, 0x00,                   //  04
    0x0F, 0xFF, 0x00,                   //  05
    0x0F, 0xFF, 0x00,                   //  06
    0x0F, 0xFF, 0x00,                   //  07
    0x0F, 0xFF, 0x00,                   //  08
    0x08, 0xEF, 0x00,                   //  09  TAB
    0x0F, 0xFF, 0x00,                   //  10
    0x0F, 0xFF, 0x00,                   //  11
    0x0F, 0xFF, 0x00,                   //  12
    0x02, 0xFB, 0x00,                   //  13  RETURN
    0x0F, 0xFF, 0x00,                   //  14
    0x0F, 0xFF, 0x00,                   //  15
    0x0F, 0xFF, 0x00,                   //  16
    0x0F, 0xFF, 0x00,                   //  17
    0x0F, 0xFF, 0x00,                   //  18
    0x0F, 0xFF, 0x00,                   //  19
    0x0F, 0xFF, 0x00,                   //  20
    0x0F, 0xFF, 0x00,                   //  21
    0x0F, 0xFF, 0x00,                   //  22
    0x0F, 0xFF, 0x00,                   //  23
    0x0F, 0xFF, 0x00,                   //  24
    0x0F, 0xFF, 0x00,                   //  25
    0x0F, 0xFF, 0x00,                   //  26
    0x0F, 0xFF, 0x00,                   //  27
    0x0F, 0xFF, 0x00,                   //  28
    0x0F, 0xFF, 0x00,                   //  29
    0x0F, 0xFF, 0x00,                   //  30
    0x0F, 0xFF, 0x00,                   //  31
    0x05, 0x7F, 0x00,                   //  32  ESPACE
    0x05, 0xFE, 0x00,                   //  33  !
    0x07, 0xFD, 0x00,                   //  34  "
    0x02, 0xF7, 0x00,                   //  35  #
    0x02, 0xBF, 0x00,                   //  36  $
    0x03, 0xEF, 0x01,                   //  37  %
    0x08, 0xFE, 0x00,                   //  38  &
    0x07, 0xFE, 0x00,                   //  39  '
    0x06, 0xFD, 0x00,                   //  40  (
    0x03, 0xFD, 0x00,                   //  41  )
    0x02, 0xFD, 0x00,                   //  42  *
    0x03, 0xBF, 0x01,                   //  43  +
    0x04, 0xBF, 0x00,                   //  44  ,
    0x03, 0xFE, 0x00,                   //  45  -
    0x04, 0x7F, 0x01,                   //  46  .
    0x03, 0x7F, 0x01,                   //  47  /
    0x04, 0xFE, 0x01,                   //  48  0
    0x08, 0xFE, 0x01,                   //  49  1
    0x08, 0xFD, 0x01,                   //  50  2
    0x07, 0xFD, 0x01,                   //  51  3
    0x07, 0xFE, 0x01,                   //  52  4
    0x06, 0xFD, 0x01,                   //  53  5
    0x06, 0xFE, 0x01,                   //  54  6
    0x05, 0xFD, 0x01,                   //  55  7
    0x05, 0xFE, 0x01,                   //  56  8
    0x04, 0xFD, 0x01,                   //  57  9
    0x03, 0x7F, 0x00,                   //  58  :
    0x04, 0x7F, 0x00,                   //  59  ;
    0x02, 0xFD, 0x01,                   //  60  <
    0x03, 0xBF, 0x00,                   //  61  =
    0x02, 0xF7, 0x01,                   //  62  >
    0x04, 0xBF, 0x01,                   //  63  ?
    0x04, 0xFE, 0x00,                   //  64  @
    0x08, 0xF7, 0x01,                   //  65  A
    0x06, 0xBF, 0x01,                   //  66  B
    0x07, 0xBF, 0x01,                   //  67  C
    0x07, 0xDF, 0x01,                   //  68  D
    0x07, 0xFB, 0x01,                   //  69  E
    0x06, 0xDF, 0x01,                   //  70  F
    0x06, 0xEF, 0x01,                   //  71  G
    0x05, 0xEF, 0x01,                   //  72  H
    0x04, 0xF7, 0x01,                   //  73  I
    0x05, 0xDF, 0x01,                   //  74  J
    0x04, 0xDF, 0x01,                   //  75  K
    0x04, 0xEF, 0x01,                   //  76  L
    0x03, 0xDF, 0x01,                   //  77  M
    0x05, 0xBF, 0x01,                   //  78  N
    0x04, 0xFB, 0x01,                   //  79  O
    0x03, 0xF7, 0x01,                   //  80  P
    0x08, 0xDF, 0x01,                   //  81  Q
    0x06, 0xFB, 0x01,                   //  82  R
    0x07, 0xEF, 0x01,                   //  83  S
    0x06, 0xF7, 0x01,                   //  84  T
    0x05, 0xFB, 0x01,                   //  85  U
    0x06, 0x7F, 0x01,                   //  86  V
    0x08, 0x7F, 0x01,                   //  87  W
    0x07, 0x7F, 0x01,                   //  88  X
    0x05, 0xF7, 0x01,                   //  89  Y
    0x07, 0xF7, 0x01,                   //  90  Z
    0x03, 0xFD, 0x01,                   //  93  [
    0x04, 0xFD, 0x00,                   //  92  \ 
    0x06, 0xFE, 0x00,                   //  91  ]
    0x03, 0xFB, 0x00,                   //  94  ^
    0x05, 0xFE, 0x00,                   //  95  _
    0x03, 0xFB, 0x00,                   //  96  `
    0x08, 0xF7, 0x00,                   //  97  a
    0x06, 0xBF, 0x00,                   //  98  b
    0x07, 0xBF, 0x00,                   //  99  c
    0x07, 0xDF, 0x00,                   // 100  d
    0x07, 0xFB, 0x00,                   // 101  e
    0x06, 0xDF, 0x00,                   // 102  f
    0x06, 0xEF, 0x00,                   // 103  g
    0x05, 0xEF, 0x00,                   // 104  h
    0x04, 0xF7, 0x00,                   // 105  i
    0x05, 0xDF, 0x00,                   // 106  j
    0x04, 0xDF, 0x00,                   // 107  k
    0x04, 0xEF, 0x00,                   // 108  l
    0x03, 0xDF, 0x00,                   // 109  m
    0x05, 0xBF, 0x00,                   // 110  n
    0x04, 0xFB, 0x00,                   // 111  o
    0x03, 0xF7, 0x00,                   // 112  p
    0x08, 0xDF, 0x00,                   // 113  q
    0x06, 0xFB, 0x00,                   // 114  r
    0x07, 0xEF, 0x00,                   // 115  s
    0x06, 0xF7, 0x00,                   // 116  t
    0x05, 0xFB, 0x00,                   // 117  u
    0x06, 0x7F, 0x00,                   // 118  v
    0x08, 0x7F, 0x00,                   // 119  w
    0x07, 0x7F, 0x00,                   // 120  x
    0x05, 0xF7, 0x00,                   // 121  y
    0x07, 0xF7, 0x00,                   // 122  z
    0x07, 0xFE, 0x00,                   // 123  {
    0x03, 0xEF, 0x00,                   // 124  |
    0x03, 0xFE, 0x00,                   // 125  }
    0x02, 0xBF, 0x00,                   // 126  ~
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,
    0x0F, 0xFF, 0x00,                   // 222
    0x0F, 0xFF, 0x00,                   // 223
    0x04, 0xFE, 0x00,                   // 224  
    0x0F, 0xFF, 0x00,                   // 225
    0x0F, 0xFF, 0x00,                   // 226
    0x0F, 0xFF, 0x00,                   // 227
    0x0F, 0xFF, 0x00,                   // 228
    0x0F, 0xFF, 0x00,                   // 229
    0x0F, 0xFF, 0x00,                   // 230
    0x04, 0xFD, 0x00,                   // 231  
    0x05, 0xFD, 0x00,                   // 232  
    0x08, 0xFD, 0x00,                   // 233  
    0x0F, 0xFF, 0x00,                   // 234
    0x0F, 0xFF, 0x00,                   // 235
    0x0F, 0xFF, 0x00,                   // 236
    0x0F, 0xFF, 0x00,                   // 237
    0x0F, 0xFF, 0x00,                   // 238
    0x0F, 0xFF, 0x00,                   // 239
    0x0F, 0xFF, 0x00,                   // 240
    0x0F, 0xFF, 0x00,                   // 241
    0x0F, 0xFF, 0x00,                   // 242
    0x0F, 0xFF, 0x00,                   // 243
    0x0F, 0xFF, 0x00,                   // 244
    0x0F, 0xFF, 0x00,                   // 245
    0x0F, 0xFF, 0x00,                   // 246
    0x0F, 0xFF, 0x00,                   // 247
    0x0F, 0xFF, 0x00,                   // 248
    0x03, 0xEF, 0x00,                   // 249  
    0x0F, 0xFF, 0x00,                   // 250
    0x0F, 0xFF, 0x00,                   // 251
    0x0F, 0xFF, 0x00,                   // 252
    0x0F, 0xFF, 0x00,                   // 253
    0x0F, 0xFF, 0x00,                   // 254
    0x0F, 0xFF, 0x00,                   // 255
    };
#endif

/********************************************************* !NAME! **************
* Nom : AjouteKeyCPC
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\\/FLE!, ligne : !./LN!
*
* Description : Envoie un caractre au CPC en fonction de la commande demande
*
* Rsultat    : La Commande, ventuellement incrmente
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
#ifdef USE_SENDKEYS
static BYTE * AjouteKeyCPC( BYTE * Commande )
{
    static int CntCmd = 0;
    static BYTE MemoLigne = 0, MemoPort = 0, MemoShift = 0;

    // Excuter seulement 1 cycle sur 2
    if ( CntCmd++ )
        {
        CntCmd = 0;
        if ( MemoPort )
            {
            clav[ MemoLigne ] |= ~MemoPort;
            if ( MemoShift )
                clav[ 0x02 ] |= ~0xDF;
            }
        if ( * Commande )
            {
            if ( ! MemoShift )
                {
                MemoPort = TabAscii[ * Commande ].Port;
                MemoLigne = TabAscii[ * Commande ].Ligne;
                MemoShift = TabAscii[ * Commande ].Shift;
                }
            else
                MemoShift = 0;

            if ( MemoShift )
                clav[ 0x02 ] &= 0xDF;
            else
                {
                clav[ MemoLigne ] &= MemoPort;
                Commande++;
                }
            }
        }
    return( Commande );
}
#endif


/********************************************************* !NAME! **************
* Nom : SupBlancsFin
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\\/FLE!, ligne : !./LN!
*
* Description : Efface les caractres trouvs  partir du caractre '-' dans
*               une chane.
*
* Rsultat    : /
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
static void SupBlancsFin( char * Msg )
{
    char * p = strchr( Msg, '-' );
    if ( p )
        * p = 0;
}


/********************************************************* !NAME! **************
* Nom : Go
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\\/FLE!, ligne : !./LN!
*
* Description : Fonction principale : boucle d'mulation
*
* Rsultat    : /
*
* Variables globales modifies : Cont
*
********************************************************** !0! ****************/
static void Go( BYTE * Commande )
{
    MSG msg;
    unsigned long TimeOut = 0, Time, OldTime = 0;
    int FrameCnt = 0, NbFrames = 0;
    int OldTrack = -1;
#ifdef USE_SAVE_AVI
    int FrameAvi = 0;
#endif
#ifdef USE_TAPE
    int CptInstr = 0, OldCptInstr = 0, CntTapeIn = 0, CntTapeOut = 0;
#endif
#ifdef USE_DESASM
    int Step = 0;
#endif

    //
    // Boucle principale...
    //
    do
        {
        int t = 0;
#ifdef USE_TAPE
        int CycleLigne = RegsCRTC[ 0 ] + 1;
#endif
#ifdef USE_DESASM
        if ( DebugMode )
            {
            if ( ! Step )
                {
                Debug( DeviceContext );
                Step = 1;
                }
            if ( PeekMessage( &msg, NULL, 0,0, PM_REMOVE ) )
                DispatchMessage( &msg );

            if ( Cont )
                {
                t += ExecInstZ80();
                Step = 0;
                Cont = 0;
                }
            }
        else
#endif
            t += ExecInstZ80();

#ifdef USE_TAPE
        //
        // Extraction des bits pour E/S cassette
        //
        if ( TpsTapeIn )
            CntTapeIn += ( CptInstr - OldCptInstr );

        if ( TpsTapeOut )
            CntTapeOut += ( CptInstr - OldCptInstr );

        if ( CptInstr < OldCptInstr )
            {
            CntTapeIn += CycleLigne;
            CntTapeOut += CycleLigne;
            }
        OldCptInstr = CptInstr;

        if ( TpsTapeIn && ( CntTapeIn >= TpsTapeIn ) )
            {
            ReadCas();
            CntTapeIn -= TpsTapeIn;
            }

        if ( TpsTapeOut && ( CntTapeOut >= TpsTapeOut ) )
            {
            WriteCas();
            CntTapeOut -= TpsTapeOut;
            }
#endif
        //
        // Gestion des compteurs : cycles d'horloges
        //
        TimeOut += t;
        CycleCRTC( t );
#ifdef FAST_SOUND_UPDATE
        Loop8912( t );
#endif
        if ( DoResync )
            {
#ifndef FAST_SOUND_UPDATE
            Loop8912( TimeOut );
#endif
            //
            // Excute les commandes si ncessaires
            //
#ifdef USE_SENDKEYS
            if ( * Commande && NbFrames > 30 )
                {
                ClavFree = FALSE;
                Commande = AjouteKeyCPC( Commande );
                }
            else
                ClavFree = TRUE;
#endif

            if ( PeekMessage( &msg, NULL, 0,0, PM_REMOVE ) )
                DispatchMessage( &msg );

            if ( ! SmallScreen )
                AffichePiste( &OldTrack, GetCurrTrack() );

#ifdef USE_SAVE_AVI
            //
            // Ecriture image cran dans fichier avi si demand
            //
            if ( WriteAviStarted() )
                // Ecriture une frame sur 2 (pour 25 Fps)
                if ( FrameAvi++ & 1 )
                    {
                    WriteAviFrame();
                    FrameAvi = 0;
                    }
#endif

#ifdef USE_SAVE_YM
            //
            // Ecriture frame son dans fichier YM si demand
            //
            if ( WriteYMStarted() )
                WriteYMFrame();
#endif

            // Lecture joystick
            TestJoy();

            //
            // Synchronisation de l'image  50 Hz
            //
            if ( ! Turbo 
#ifdef USE_SAVE_AVI
               || WriteAviStarted()
#endif
               )
                {
                // Test pour 60 hz
#ifdef USE_DIRECTX
                if ( UsePcVBL )
                    {
#ifdef TEST_VBL_DIRECTX
                    lpDD->WaitForVerticalBlank( DDWAITVB_BLOCKEND, 0 );
#else
                    BOOL PcVBL;
                    do
                        {
                        lpDD->GetVerticalBlankStatus( &PcVBL );
                        if ( PeekMessage( &msg, NULL, 0,0, PM_REMOVE ) )
                            DispatchMessage( &msg );
                        }
                    while( ! PcVBL );
#endif
                    }
                else
#endif
                    {
                    do
                        {
                        Time = timeGetTime() * 1000;
                        Sleep( Time - OldTime < TimeOut - 1000 ? 1 : 0 );
                        }
                    while( Time - OldTime < TimeOut );
                    OldTime = Time;
                    }
                }
            DoResync = TimeOut = 0;

            //
            // Rafraichissement de l'cran...
            //
            if ( ++FrameCnt > FrameSkip )
                {
                FrameCnt = 0;
                NbFrames++;
                UpdateScreen();
                }
            }
        }
    while( ! finMain );
}


/********************************************************* !NAME! **************
* Nom : WinMain
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\\/FLE!, ligne : !./LN!
*
* Description : Point d'entre du programme
*
* Rsultat    : 0
*
* Variables globales modifies :
*
********************************************************** !0! ****************/
int APIENTRY WinMain( HINSTANCE hInstance
                    , HINSTANCE hPrevInstance
                    , LPSTR     lpCmdLine
                    , int       nCmdShow
                    )
{
    char * Msg;
    static char LogMsg[ 80 ];
    static BYTE RunCmd[ 0x1000 ];
    static char MsgTmp[ 256 ];

    * RunCmd = 0;
    Msg = lpCmdLine;
    hPrevInstance = 0;          // Eviter un warning
    if ( ReadConfig() )
        {
#ifdef USE_LOG
        if ( StartLog( "Z80.LOG" ) )
            {
#endif
            if ( InitMemCPC() )
                {
#ifdef USE_MULTIFACE
                if ( ! Multiface || InitMultiface() )
#endif
                    {
                    if ( InitInstance( hInstance, nCmdShow ) )
                        {
#ifdef USE_PRINTER
                        if ( UsePrinter )
                            StartPrinter( "print.txt" );
#endif
                        if ( timeBeginPeriod( 1 ) != TIMERR_NOERROR )
                            MessageBox( NULL
                                      , "Problme de rsolution de timer, l'mulateur aura une vitesse incorrecte..."
                                      , NULL
                                      , MB_ICONWARNING
                                      );
#ifdef USE_ROM_PACK
                        if ( ! InitConversion() )
#endif
                            {
                            //
                            // Initialisations diverses
                            //
                            ResetZ80();
                            ResetUPD();
                            ResetCRTC();
                            Reset8912();
                            InitPlateforme();
                            InitSound();
                            AfficheInfos();
                            //
                            // Dcode les arguments de la ligne de commande
                            //
                            if ( * Msg )
                                {
                                do
                                    {
                                    char * p = Msg;
                                    if ( * p == '-' )
                                        {
                                        p++;
                                        if ( ! strncmp( p, "disk", 4 ) )
                                            {
                                            strcpy( MsgTmp, &p[ 5 ] );
                                            SupBlancsFin( MsgTmp );
#ifdef USE_NEWDISC
                                            NewDiscOn = FALSE;
#endif
                                            SetDiskUPD( hWnd, MsgTmp );
                                            }
                                        if ( ! strncmp( p, "snapshot", 8 ) )
                                            {
                                            strcpy( MsgTmp, &p[ 9 ] );
                                            SupBlancsFin( MsgTmp );
                                            LireSnap( MsgTmp );
                                            }
#ifdef USE_SENDKEYS
                                        int i;

                                        if ( ! strncmp( p, "run", 3 ) )
                                            {
                                            strcpy( MsgTmp, &p[ 4 ] );
                                            SupBlancsFin( MsgTmp );
                                            memcpy( RunCmd, "run\"", 4 );
                                            for ( i = 0; i < strlen( MsgTmp ); i++ )
                                                RunCmd[ i + 4 ] = ( BYTE )toupper( MsgTmp[ i ] );

                                            RunCmd[ i + 4 ] = '\r';
                                            RunCmd[ i + 5 ] = 0;
                                            }
                                        if ( ! strncmp( p, "cmd", 3 ) )
                                            {
                                            strcpy( ( char * )RunCmd, &p[ 4 ] );
                                            strcat( ( char * )RunCmd, "\r" );
                                            }
                                        if ( ! strncmp( p, "file", 4 ) )
                                            {
                                            FILE * fp = fopen( &p[ 5 ], "rt" );
                                            if ( fp )
                                                {
                                                * RunCmd = 0;
                                                i = 0;
                                                while( fgets( MsgTmp
                                                            , sizeof( MsgTmp )
                                                            , fp
                                                            )
                                                     )
                                                    {
                                                    i += 1 + strlen( MsgTmp );
                                                    if ( i < sizeof( RunCmd ) )
                                                        {
                                                        strcat( ( char * )RunCmd
                                                              , MsgTmp
                                                              );
                                                        strcat( ( char * )RunCmd
                                                              , "\r"
                                                              );
                                                        }
                                                    else
                                                        break;
                                                    }
                                                fclose( fp );
                                                }
                                            }
#endif
                                        }
                                    p = strchr( Msg, ' ' );
                                    if ( p )
                                        Msg = ++p;
                                    else
                                        Msg++;
                                    }
                                while( * Msg );
                                }

                            Go( RunCmd );
                            EjectDiskUPD( NULL );
#ifdef USE_TAPE
                            CloseTapIn();
                            CloseTapOut();
#endif
                            EndSound();
#ifdef USE_PROFILE
                            EndProfile();
#endif
                            }
#ifdef USE_ROM_PACK
                        else
                            {
                            strcpy( MsgLog, "Impossible d'initialiser le module de conversion" );
#ifdef USE_LOG
                            Log( MODULENAME, MsgLog, LOG_WARNING );
#endif
                            Erreur( MsgLog );
                            }
                        EndConversion();
#endif
                        timeEndPeriod( 1 );

#ifdef USE_PRINTER
                        if ( UsePrinter )
                            EndPrinter();
#endif

#ifdef USE_SAVE_AVI
                        if ( WriteAviStarted() )
                            WriteAviEnd( hWnd );
#endif

#ifdef USE_SAVE_YM
                        if ( WriteYMStarted() )
                            WriteYMEnd( hWnd );
#endif
                        }
                    else
                        {
                        strcpy( MsgLog, "Impossible d'instancier la fentre de l'mulateur" );
#ifdef USE_LOG
                        Log( MODULENAME, MsgLog, LOG_WARNING );
#endif
                        Erreur( MsgLog );
                        }
                    }
#ifdef USE_MULTIFACE
                else
                    {
                    strcpy( MsgLog, "Rom multiface non trouve" );
#ifdef USE_LOG
                    Log( MODULENAME, MsgLog, LOG_WARNING );
#endif
                    Erreur( MsgLog );
                    }
#endif
                }
            else
                {
                strcpy( MsgLog, "Roms du CPC non trouves" );
#ifdef USE_LOG
                Log( MODULENAME, MsgLog, LOG_WARNING );
#endif
                Erreur( MsgLog );
                }

#ifdef USE_LOG
            EndLog();
            }
        else
            Erreur( "Impossible d'ouvrir le fichier de trace" );
#endif
        }
    else
        Erreur( "Fichier de configuration du CPC non trouv." );

    ReleaseResources();
    return( 0 );
}
