/******************************************************************************/
/* Configuration pour l'archivage des diffrents lments du fichier source   */
/******************************************************************************/
// !CONFIG!=/L/* /R/* /W"* Nom : "
// Dfinition du systme       !CONFIG!=/V1!EMULATEUR CPC!
// Dfinition du sous systme  !CONFIG!=/V2!PC-CPC!
// Dfinition du sous ensemble !CONFIG!=/V3!Noyau!
// Dfinition du module        !CONFIG!=/V4!Ecran Clavier!
/******************************************************************************/

/********************************************************* !NAME! **************
* !./FLE!
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\Fichiers
********************************************************** !0! *****************
* ------------------------------------------------------------------------------
*          SYSTEME         |      SOUS SYSTEME       |      SOUS ENSEMBLE
* ------------------------------------------------------------------------------
*  EMULATEUR CPC           | PC-CPC                  | Noyau
* ------------------------------------------------------------------------------
*  Fichier     : PLATEFORM.C           | Version : 0.1an
* ------------------------------------------------------------------------------
*  Date        : 05/11/2002            | Auteur  : L.DEPLANQUE
* ------------------------------------------------------------------------------
*  Description : Gestion cran, clavier
*
* ------------------------------------------------------------------------------
*  Historique  :
*           Date           |         Auteur          |       Description
* ------------------------------------------------------------------------------
*  05/11/2002              | L.DEPLANQUE             | creation
* ------------------------------------------------------------------------------
*  07/11/2002              | L.DEPLANQUE             | Ajout gestion lecture et
*                          |                         | criture cassette :
*                          |                         | touches F9 (lecture) et
*                          |                         | F11 (criture)
* ------------------------------------------------------------------------------
*  13/11/2002              | L.DEPLANQUE             | Passage du nom de fichier
*                          |                         | snapshot en paramtre aux
*                          |                         | fonctions LireSnap() et
*                          |                         | SauveSnap().  
* ------------------------------------------------------------------------------
*  06/01/2003              | L.DEPLANQUE             | Version 0.1t : Happy new
*                          |                         | Year
* ------------------------------------------------------------------------------
*  09/01/2003              | L.DEPLANQUE             | Version 0.1u : Ajout d'un
*                          |                         | tableau pour permettre la
*                          |                         | redfinition dynamique
*                          |                         | des touches mulant le
*                          |                         | joystick
* ------------------------------------------------------------------------------
*  03/02/2003              | L.DEPLANQUE             | Version 0.1v : Gestion
*                          |                         | localisation fichiers
*                          |                         | DSK, SNA, TAP
* ------------------------------------------------------------------------------
*  06/05/2003              | L.DEPLANQUE             | Version 0.1w : Correction
*                          |                         | d'un bug dans le mapping
*                          |                         | des touches joystick :
*                          |                         | Le membre .Ligne ne doit
*                          |                         | pas dpasser 0x0F (15)
*                          |                         | car clav[ nb=16 ]        
* ------------------------------------------------------------------------------
*  25/02/2004              | L.DEPLANQUE             | Version 0.1y : Changement
*                          |                         | du nom de l'application
*                          |                         | dans le titre de la
*                          |                         | fentre (PC-CPC) et
*                          |                         | mise  disposition de la
*                          |                         | variable de titre        
* ------------------------------------------------------------------------------
*  30/03/2004              | L.DEPLANQUE             | Version 0.1z
* ------------------------------------------------------------------------------
*  21/04/2004              | L.DEPLANQUE             | Version 0.1aa :
*                          |                         | Correction d'un petit
*                          |                         | bug dans les fonctions
*                          |                         | de dessin des lignes
*                          |                         | cran : couleur du bord
* ------------------------------------------------------------------------------
*  04/11/2004              | L.DEPLANQUE             | Version 0.1ad :
*                          |                         | Possibilit de choisir
*                          |                         | le rpertoire dans le
*                          |                         | mode mulation fichier
*                          |                         | et affichage du
*                          |                         | rpertoire ou de la
*                          |                         | disquette en cours
* ------------------------------------------------------------------------------
*  16/05/2005              | L.DEPLANQUE             | Version 0.1af :
*                          |                         | Modification gestion des
*                          |                         | touches F7 et F12 :
*                          |                         | F7 passe en mode "dsk" et
*                          |                         | F12 pass en mode "direct"
* ------------------------------------------------------------------------------
*  02/06/2005              | L.DEPLANQUE             | Version 0.1ag :
*                          |                         | Utilisation de fichiers
*                          |                         | .WAV pour l'mulation de
*                          |                         | lecture et criture sur
*                          |                         | cassette
* ------------------------------------------------------------------------------
*  30/11/2005              | L.DEPLANQUE             | Version 0.1ah:
*                          |                         | Gestion touche 'fin'
*                          |                         | pour sauvegarde .AVI
* ------------------------------------------------------------------------------
*  08/12/2005              | L.DEPLANQUE             | Version 0.1ai:
*                          |                         | Mmorise le nom du
*                          |                         | dernier fichier DSK
*                          |                         | charg.
*                          |                         | Modification paramtres
*                          |                         | bitmap pour sauvegarde
*                          |                         | BMP
* ------------------------------------------------------------------------------
*  07/02/2006              | L.DEPLANQUE             | Version 0.1ak:
*                          |                         | Modification routines
*                          |                         | de trac de lignes
* ------------------------------------------------------------------------------
*  21/07/2006              | L.DEPLANQUE             | Version 0.1al:
*                          |                         | Possibilit d'utiliser
*                          |                         | une fentre sans bords
*                          |                         | ni barre de titre
*                          |                         | Modification affectation
*                          |                         | touches fonctions (avec
*                          |                         | shift)
*                          |                         | Prise en compte du
*                          |                         | joystick
* ------------------------------------------------------------------------------
*  21/08/2006              | L.DEPLANQUE             | Version 0.1am:
*                          |                         | Suppression du mode
*                          |                         | "Ligne directe".
*                          |                         | Possibilit de changer
*                          |                         | de rsolution en cours
*                          |                         | de fonctionnement.
* ------------------------------------------------------------------------------
*  05/03/2007              | L.DEPLANQUE             | Version 0.1an:
*                          |                         | Remplacement des fcts de
*                          |                         | trac de lignes par des
*                          |                         | fcts de trac de mots
*                          |                         | (CRTC prcis au mot)
*                          |                         | Amlioration du rendu
*                          |                         | des couleurs en mode
*                          |                         | 32 bits et petit cran.
*                          |                         | Gestion des 10 boutons
*                          |                         | du joystick 1 avec la
*                          |                         | possibilit d'affecter
*                          |                         | une touche du clavier
*                          |                         |  chaque fonction du
*                          |                         | joystick.
*                          |                         | Ajout de la touche
*                          |                         | SHIFT+F6 pour minimiser
*                          |                         | la fentre.
* ------------------------------------------------------------------------------
********************************************************** !END! **************/


#include  <windows.h>
#include  <ddraw.h>
#include  <shlobj.h>
#include  <stdio.h>
#include  <mmsystem.h>

#include  "types.h"
#ifdef USE_TAPE
#include  "PosFileTape.h"
#endif
#include  "plateform.h"
#ifdef USE_MULTIFACE
#include  "multiface.h"
#endif
#include  "snapshot.h"
#ifdef USE_SAVE_BMP
#include  "SauveBmp.h"
#endif
#ifdef USE_NEWDISC
#include  "newdisc.h"
#endif
#include  "config.h"
#include  "AY8912.h"
#include  "sound.h"
#include  "z80.h"
#include  "ppi.h"
#include  "vga.h"
#include  "upd.h"
#include  "crtc.h"
#ifdef USE_LOG
#include  "log.h"
#endif
#ifdef USE_SAVE_AVI
#include  "WriteAvi.h"
#endif
#ifdef USE_SAVE_YM
#include  "WriteYM.h"
#endif
#include  "Aide.h"


#define     MODULENAME      "Plateform"


//
// Nombre max. de modes plein cran
//
#define     D3DAPP_MAXMODES     1024


/********************************************************* !NAME! **************
* Nom : StMode
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Structures
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Structure modes plein cran
*
********************************************************** !0! ****************/
typedef struct
    {
    int TailleX;
    int TailleY;
    int Depth;
    } StMode;


extern int finMain;


/********************************************************* !NAME! **************
* Nom : lpDD
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Pointeur sur objet DirectDraw
*
********************************************************** !0! ****************/
#ifdef USE_DIRECTX
LPDIRECTDRAW lpDD = NULL;
#endif


/********************************************************* !NAME! **************
* Nom : TailleWinX
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Taille de la fentre en X
*
********************************************************** !0! ****************/
static int TailleWinX = 320;


/********************************************************* !NAME! **************
* Nom : TailleWinY
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Taille de la fentre en Y
*
********************************************************** !0! ****************/
static int TailleWinY = 200;


/********************************************************* !NAME! **************
* Nom : f
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Police utilise pour affichage cran
*
********************************************************** !0! ****************/
static HFONT f;


#ifdef USE_DIRECTX
/********************************************************* !NAME! **************
* Nom : lpDDSPrimary
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Pointeur sur objet DirectDrawSurface
*
********************************************************** !0! ****************/
static LPDIRECTDRAWSURFACE lpDDSPrimary = NULL;


/********************************************************* !NAME! **************
* Nom : TabModes
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Tableau contenant la liste des modes plein cran
*
********************************************************** !0! ****************/
static StMode TabModes[ D3DAPP_MAXMODES ];


/********************************************************* !NAME! **************
* Nom : NbModes
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Nombre de modes plein cran
*
********************************************************** !0! ****************/
static int NbModes;
#endif


/********************************************************* !NAME! **************
* Nom : hWnd
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Handle de la fentre principale
*
********************************************************** !0! ****************/
HWND hWnd;


/********************************************************* !NAME! **************
* Nom : DeviceContext
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : structure HDC de la fentre principale
*
********************************************************** !0! ****************/
HDC DeviceContext = NULL;


/********************************************************* !NAME! **************
* Nom : hInst
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Instance de l'application
*
********************************************************** !0! ****************/
static HINSTANCE hInst;


/********************************************************* !NAME! **************
* Nom : DcBitmap
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Structure HDC du bitmap reprsentant la mmoire cran CPC
*
********************************************************** !0! ****************/
static HDC DcBitmap = NULL;


/********************************************************* !NAME! **************
* Nom : bm
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Handle vers le bitmap contenant l'image de l'cran du CPC
*
********************************************************** !0! ****************/
static HBITMAP bm = NULL;


/********************************************************* !NAME! **************
* Nom : MemBitmap
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Buffer contenant l'image de l'cran du CPC
*
********************************************************** !0! ****************/
int * MemBitmap;


/********************************************************* !NAME! **************
* Nom : pbmi
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Information sur la structure du bitmap reprsentant l'cran du
*               CPC
*
********************************************************** !0! ****************/
BITMAPINFO pbmi;


/********************************************************* !NAME! **************
* Nom : NomDisc
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Mmorise le nom de la disquette en cours
*
********************************************************** !0! ****************/
char NomDisc[ MAX_PATH ];


/********************************************************* !NAME! **************
* Nom : DrawFct
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Fonction de trac d'une ligne
*
********************************************************** !0! ****************/
pfctDraw DrawFct;


/********************************************************* !NAME! **************
* Nom : LastMode
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Mode cran slectionn
*
********************************************************** !0! ****************/
int LastMode;


/********************************************************* !NAME! **************
* Nom : Turbo
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Mode turbo activ/dsactiv
*
********************************************************** !0! ****************/
int Turbo = 0;


/********************************************************* !NAME! **************
* Nom : Monochrome
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Mode Monochrome activ/dsactiv
*
********************************************************** !0! ****************/
int Monochrome = 0;


#ifdef USE_DESASM
/********************************************************* !NAME! **************
* Nom : DebugMode
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Mode debug activ/dsactiv
*
********************************************************** !0! ****************/
int DebugMode = 0;


/********************************************************* !NAME! **************
* Nom : Cont
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Droulement instructions en continu ou non
*
********************************************************** !0! ****************/
int Cont = 1;
#endif


/********************************************************* !NAME! **************
* Nom : ClavFree
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Indique si la gestion du clavier est possible ou non
*
********************************************************** !0! ****************/
#ifdef USE_SENDKEYS
BOOL ClavFree = TRUE;
#endif


/********************************************************* !NAME! **************
* Nom : TrKey
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Transformations touches PC -> CPC
*
********************************************************** !0! ****************/
static stToucheClav TrKey[ 256 ] =
    {
        { 0xFF, 0x0F },           // 0x00
        { 0xFF, 0x0F },           // 0x01
        { 0xFF, 0x0F },           // 0x02
        { 0xFF, 0x0F },           // 0x03
        { 0xFF, 0x0F },           // 0x04
        { 0xFF, 0x0F },           // 0x05
        { 0xFF, 0x0F },           // 0x06
        { 0xFF, 0x0F },           // 0x07
        { 0x7F, 0x09 },           // DEL
        { 0xEF, 0x08 },           // TAB
        { 0xFF, 0x0F },           // 0x0A
        { 0xFF, 0x0F },           // 0x0B
        { 0xFF, 0x0F },           // 0x0C
        { 0xFB, 0x02 },           // ENTER
        { 0xFF, 0x0F },           // 0x0E
        { 0xFF, 0x0F },           // 0x0F
        { 0xDF, 0x02 },           // SHIFT
        { 0x7F, 0x02 },           // CTRL
        { 0xFD, 0x01 },           // ALTGR -> COPY
        { 0xFF, 0x0F },           // 0x13
        { 0xBF, 0x08 },           // CAPS LOCK
        { 0xFF, 0x0F },           // 0x15
        { 0xFF, 0x0F },           // 0x16
        { 0xFF, 0x0F },           // 0x17
        { 0xFF, 0x0F },           // 0x18
        { 0xFF, 0x0F },           // 0x19
        { 0xFF, 0x0F },           // 0x1A
        { 0xFB, 0x08 },           // ESC
        { 0xFF, 0x0F },           // 0x1C
        { 0xFF, 0x0F },           // 0x1D
        { 0xFF, 0x0F },           // 0x1E
        { 0xFF, 0x0F },           // 0x1F
        { 0x7F, 0x05 },           // ' '
        { 0xFF, 0x0F },           // 0x21
        { 0xFF, 0x0F },           // 0x22
        { 0xFF, 0x0F },           // 0x23
        { 0xFF, 0x0F },           // 0x24
        { 0xFE, 0x01 },           // Fleche Gauche
        { 0xFE, 0x00 },           // Fleche Haut
        { 0xFD, 0x00 },           // Fleche Droite
        { 0xFB, 0x00 },           // Fleche Bas
        { 0xFF, 0x0F },           // 0x29
        { 0xFF, 0x0F },           // 0x2A
        { 0xFF, 0x0F },           // 0x2B
        { 0xFF, 0x0F },           // 0x2C
        { 0xFF, 0x0F },           // 0x2D
        { 0xFE, 0x02 },           // SUPPR
        { 0xFF, 0x0F },           // 0x2F
        { 0xFE, 0x04 },           // '0'
        { 0xFE, 0x08 },           // '1'
        { 0xFD, 0x08 },           // '2'
        { 0xFD, 0x07 },           // '3'
        { 0xFE, 0x07 },           // '4'
        { 0xFD, 0x06 },           // '5'
        { 0xFE, 0x06 },           // '6'
        { 0xFD, 0x05 },           // '7'
        { 0xFE, 0x05 },           // '8'
        { 0xFD, 0x04 },           // '9'
        { 0xFF, 0x0F },           // 0x3A
        { 0xFF, 0x0F },           // 0x3B
        { 0xFF, 0x0F },           // 0x3C
        { 0xFF, 0x0F },           // 0x3D
        { 0xFF, 0x0F },           // 0x3E
        { 0xFF, 0x0F },           // 0x3F
        { 0xFF, 0x0F },           // 0x40
        { 0xF7, 0x08 },           // 'A'
        { 0xBF, 0x06 },           // 'B'
        { 0xBF, 0x07 },           // 'C'
        { 0xDF, 0x07 },           // 'D'
        { 0xFB, 0x07 },           // 'E'
        { 0xDF, 0x06 },           // 'F'
        { 0xEF, 0x06 },           // 'G'
        { 0xEF, 0x05 },           // 'H'
        { 0xF7, 0x04 },           // 'I'
        { 0xDF, 0x05 },           // 'J'
        { 0xDF, 0x04 },           // 'K'
        { 0xEF, 0x04 },           // 'L'
        { 0xDF, 0x03 },           // 'M'
        { 0xBF, 0x05 },           // 'N'
        { 0xFB, 0x04 },           // 'O'
        { 0xF7, 0x03 },           // 'P'
        { 0xDF, 0x08 },           // 'Q'
        { 0xFB, 0x06 },           // 'R'
        { 0xEF, 0x07 },           // 'S'
        { 0xF7, 0x06 },           // 'T'
        { 0xFB, 0x05 },           // 'U'
        { 0x7F, 0x06 },           // 'V'
        { 0x7F, 0x08 },           // 'W'
        { 0x7F, 0x07 },           // 'X'
        { 0xF7, 0x05 },           // 'Y'
        { 0xF7, 0x07 },           // 'Z'
        { 0xFF, 0x0F },           // 0x5B
        { 0xFF, 0x0F },           // 0x5C
        { 0xFD, 0x01 },           // menu contextuel -> COPY
        { 0xFF, 0x0F },           // 0x5E
        { 0xFF, 0x0F },           // 0x5F
        { 0x7F, 0x01 },           // P'0'
        { 0xDF, 0x01 },           // P'1'
        { 0xBF, 0x01 },           // P'2'
        { 0xDF, 0x00 },           // P'3'
        { 0xEF, 0x02 },           // P'4'
        { 0xEF, 0x01 },           // P'5'
        { 0xEF, 0x00 },           // P'6'
        { 0xFB, 0x01 },           // P'7'
        { 0xF7, 0x01 },           // P'8'
        { 0xF7, 0x00 },           // P'9'
        { 0xFF, 0x0F },           // 0x6A
        { 0xFF, 0x0F },           // 0x6B
        { 0xFF, 0x0F },           // 0x6C
        { 0xFF, 0x0F },           // 0x6D
        { 0x7F, 0x00 },           // P'.'
        { 0xFF, 0x0F },           // 0x6F
        { 0xFF, 0x0F },           // 0x70
        { 0xFF, 0x0F },           // 0x71
        { 0xFF, 0x0F },           // 0x72
        { 0xFF, 0x0F },           // 0x73
        { 0xFF, 0x0F },           // 0x74
        { 0xFF, 0x0F },           // 0x75
        { 0xFF, 0x0F },           // 0x76
        { 0xFF, 0x0F },           // 0x77
        { 0xFF, 0x0F },           // 0x78
        { 0xFF, 0x0F },           // 0x79
        { 0xFF, 0x0F },           // 0x7A
        { 0xFF, 0x0F },           // 0x7B
        { 0xFF, 0x0F },           // 0x7C
        { 0xFF, 0x0F },           // 0x7D
        { 0xFF, 0x0F },           // 0x7E
        { 0xFF, 0x0F },           // 0x7F
        { 0xFF, 0x0F },           // 0x80
        { 0xFF, 0x0F },           // 0x81
        { 0xFF, 0x0F },           // 0x82
        { 0xFF, 0x0F },           // 0x83
        { 0xFF, 0x0F },           // 0x84
        { 0xFF, 0x0F },           // 0x85
        { 0xFF, 0x0F },           // 0x86
        { 0xFF, 0x0F },           // 0x87
        { 0xFF, 0x0F },           // 0x88
        { 0xFF, 0x0F },           // 0x89
        { 0xFF, 0x0F },           // 0x8A
        { 0xFF, 0x0F },           // 0x8B
        { 0xFF, 0x0F },           // 0x8C
        { 0xFF, 0x0F },           // 0x8D
        { 0xFF, 0x0F },           // 0x8E
        { 0xFF, 0x0F },           // 0x8F
        { 0xFF, 0x0F },           // 0x90
        { 0xFF, 0x0F },           // 0x91
        { 0xFF, 0x0F },           // 0x92
        { 0xFF, 0x0F },           // 0x93
        { 0xFF, 0x0F },           // 0x94
        { 0xFF, 0x0F },           // 0x95
        { 0xFF, 0x0F },           // 0x96
        { 0xFF, 0x0F },           // 0x97
        { 0xFF, 0x0F },           // 0x98
        { 0xFF, 0x0F },           // 0x99
        { 0xFF, 0x0F },           // 0x9A
        { 0xFF, 0x0F },           // 0x9B
        { 0xFF, 0x0F },           // 0x9C
        { 0xFF, 0x0F },           // 0x9D
        { 0xFF, 0x0F },           // 0x9E
        { 0xFF, 0x0F },           // 0x9F
        { 0xFF, 0x0F },           // 0xA0
        { 0xFF, 0x0F },           // 0xA1
        { 0xFF, 0x0F },           // 0xA2
        { 0xFF, 0x0F },           // 0xA3
        { 0xFF, 0x0F },           // 0xA4
        { 0xFF, 0x0F },           // 0xA5
        { 0xFF, 0x0F },           // 0xA6
        { 0xFF, 0x0F },           // 0xA7
        { 0xFF, 0x0F },           // 0xA8
        { 0xFF, 0x0F },           // 0xA9
        { 0xFF, 0x0F },           // 0xAA
        { 0xFF, 0x0F },           // 0xAB
        { 0xFF, 0x0F },           // 0xAC
        { 0xFF, 0x0F },           // 0xAD
        { 0xFF, 0x0F },           // 0xAE
        { 0xFF, 0x0F },           // 0xAF
        { 0xFF, 0x0F },           // 0xB0
        { 0xFF, 0x0F },           // 0xB1
        { 0xFF, 0x0F },           // 0xB2
        { 0xFF, 0x0F },           // 0xB3
        { 0xFF, 0x0F },           // 0xB4
        { 0xFF, 0x0F },           // 0xB5
        { 0xFF, 0x0F },           // 0xB6
        { 0xFF, 0x0F },           // 0xB7
        { 0xFF, 0x0F },           // 0xB8
        { 0xFF, 0x0F },           // 0xB9
        { 0xBF, 0x02 },           // '$'
        { 0xFE, 0x03 },           // '='
        { 0xBF, 0x04 },           // ','
        { 0xFF, 0x0F },           // 0xBD
        { 0x7F, 0x04 },           // ';'
        { 0x7F, 0x03 },           // ':'
        { 0xEF, 0x03 },           // ''
        { 0xFF, 0x0F },           // 0xC1
        { 0xFF, 0x0F },           // 0xC2
        { 0xFF, 0x0F },           // 0xC3
        { 0xFF, 0x0F },           // 0xC4
        { 0xFF, 0x0F },           // 0xC5
        { 0xFF, 0x0F },           // 0xC6
        { 0xFF, 0x0F },           // 0xC7
        { 0xFF, 0x0F },           // 0xC8
        { 0xFF, 0x0F },           // 0xC9
        { 0xFF, 0x0F },           // 0xCA
        { 0xFF, 0x0F },           // 0xCB
        { 0xFF, 0x0F },           // 0xCC
        { 0xFF, 0x0F },           // 0xCD
        { 0xFF, 0x0F },           // 0xCE
        { 0xFF, 0x0F },           // 0xCF
        { 0xFF, 0x0F },           // 0xD0
        { 0xFF, 0x0F },           // 0xD1
        { 0xFF, 0x0F },           // 0xD2
        { 0xFF, 0x0F },           // 0xD3
        { 0xFF, 0x0F },           // 0xD4
        { 0xFF, 0x0F },           // 0xD5
        { 0xFF, 0x0F },           // 0xD6
        { 0xFF, 0x0F },           // 0xD7
        { 0xFF, 0x0F },           // 0xD8
        { 0xFF, 0x0F },           // 0xD9
        { 0xFF, 0x0F },           // 0xDA
        { 0xFD, 0x03 },           // ')'
        { 0xFD, 0x02 },           // '#'
        { 0xFB, 0x03 },           // '^'
        { 0xF7, 0x02 },           // '*'
        { 0xBF, 0x03 },           // '!'
        { 0xFF, 0x0F },           // 0xE0
        { 0xFF, 0x0F },           // 0xE1
        { 0xFF, 0x0F },           // 0xE2
        { 0xFF, 0x0F },           // 0xE3
        { 0xFF, 0x0F },           // 0xE4
        { 0xFF, 0x0F },           // 0xE5
        { 0xFF, 0x0F },           // 0xE6
        { 0xFF, 0x0F },           // 0xE7
        { 0xFF, 0x0F },           // 0xE8
        { 0xFF, 0x0F },           // 0xE9
        { 0xFF, 0x0F },           // 0xEA
        { 0xFF, 0x0F },           // 0xEB
        { 0xFF, 0x0F },           // 0xEC
        { 0xFF, 0x0F },           // 0xED
        { 0xFF, 0x0F },           // 0xEE
        { 0xFF, 0x0F },           // 0xEF
        { 0xFF, 0x0F },           // 0xF0
        { 0xFF, 0x0F },           // 0xF1
        { 0xFF, 0x0F },           // 0xF2
        { 0xFF, 0x0F },           // 0xF3
        { 0xFF, 0x0F },           // 0xF4
        { 0xFF, 0x0F },           // 0xF5
        { 0xFF, 0x0F },           // 0xF6
        { 0xFF, 0x0F },           // 0xF7
        { 0xFF, 0x0F },           // 0xF8
        { 0xFF, 0x0F },           // 0xF9
        { 0xFF, 0x0F },           // 0xFA
        { 0xFF, 0x0F },           // 0xFB
        { 0xFF, 0x0F },           // 0xFC
        { 0xFF, 0x0F },           // 0xFD
        { 0xFF, 0x0F },           // 0xFE
        { 0xFF, 0x0F },           // 0xFF
    };


/********************************************************* !NAME! **************
* Nom : TabPoints
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Conversions pixels CPC -> cran PC
*
********************************************************** !0! ****************/
static int TabPoints[ 4 ][ 256 ][ 8 ];


/********************************************************* !NAME! **************
* Nom : Border
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Variables Globales
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Couleur du bord pour 8 pixels en mode 2
*
********************************************************** !0! ****************/
static int Border[ 8 ] = { 16, 16, 16, 16, 16, 16, 16, 16 };


/********************************************************* !NAME! **************
* Nom : CalcPoints
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Calcule l'image des points  afficher  l'cran en fonction du
*               mode d'affichage du CPC (mode 0, 1 ou 2)
*
* Rsultat    : /
*
* Variables globales modifies : TabPoints
*
********************************************************** !0! ****************/
static void CalcPoints( void )
{
    int a, b, c, d, i, j;

    for ( i = 0; i < 256; i++ )
        {
        // Pour le mode 0
        a = ( i >> 7 )
          + ( ( i & 0x20 ) >> 3 )
          + ( ( i & 0x08 ) >> 2 )
          + ( ( i & 0x02 ) << 2 );
        b = ( ( i & 0x40 ) >> 6 )
          + ( ( i & 0x10 ) >> 2 )
          + ( ( i & 0x04 ) >> 1 )
          + ( ( i & 0x01 ) << 3 );
        TabPoints[ 0 ][ i ][ 0 ] = 
        TabPoints[ 0 ][ i ][ 1 ] = 
        TabPoints[ 0 ][ i ][ 2 ] = 
        TabPoints[ 0 ][ i ][ 3 ] = a;
        TabPoints[ 0 ][ i ][ 4 ] = 
        TabPoints[ 0 ][ i ][ 5 ] = 
        TabPoints[ 0 ][ i ][ 6 ] = 
        TabPoints[ 0 ][ i ][ 7 ] = b;

        // Pour le mode 1
        a = ( i >> 7 ) + ( ( i & 0x08 ) >> 2 );
        b = ( ( i & 0x40 ) >> 6 ) + ( ( i & 0x04 ) >> 1 );
        c = ( ( i & 0x20 ) >> 5 ) + ( i & 0x02 );
        d = ( ( i & 0x10 ) >> 4 ) + ( ( i & 0x01 ) << 1 );
        TabPoints[ 1 ][ i ][ 0 ] = 
        TabPoints[ 1 ][ i ][ 1 ] = a;
        TabPoints[ 1 ][ i ][ 2 ] = 
        TabPoints[ 1 ][ i ][ 3 ] = b;
        TabPoints[ 1 ][ i ][ 4 ] = 
        TabPoints[ 1 ][ i ][ 5 ] = c;
        TabPoints[ 1 ][ i ][ 6 ] = 
        TabPoints[ 1 ][ i ][ 7 ] = d;
    
        // Pour le mode 2
        TabPoints[ 2 ][ i ][ 0 ] = ( i >> 7 );
        TabPoints[ 2 ][ i ][ 1 ] = ( ( i & 0x40 ) >> 6 );
        TabPoints[ 2 ][ i ][ 2 ] = ( ( i & 0x20 ) >> 5 );
        TabPoints[ 2 ][ i ][ 3 ] = ( ( i & 0x10 ) >> 4 );
        TabPoints[ 2 ][ i ][ 4 ] = ( ( i & 0x08 ) >> 3 );
        TabPoints[ 2 ][ i ][ 5 ] = ( ( i & 0x04 ) >> 2 );
        TabPoints[ 2 ][ i ][ 6 ] = ( ( i & 0x02 ) >> 1 );
        TabPoints[ 2 ][ i ][ 7 ] = ( i & 0x01 );

        // Mode 3 = Mode 0 ???
        for ( j = 0; j < 8; j++ )
            TabPoints[ 3 ][ i ][ j ] = TabPoints[ 0 ][ i ][ j ];
        }
}


/********************************************************* !NAME! **************
* Nom : SetLedFDC
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Affiche l'tat de la LED du contrleur disc
*
* Rsultat    : /
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
void SetLedFDC( int Etat )
{
    static RECT Rect = { 660, 550, 674, 556 };

    if ( ! SmallScreen )
        {
        HBRUSH br = CreateSolidBrush( RGB( Etat ? 0xFF : 0x40, 0x00, 0x00 ) );
        FillRect( DeviceContext, &Rect, br );
        DeleteObject( br );
        }
}


/********************************************************* !NAME! **************
* Nom : AffichePiste
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\\/FLE!, ligne : !./LN!
*
* Description : Affichage du numro de piste en cours (disquette)
*
* Rsultat    : /
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
void AffichePiste( int * OldTrack, int CurrTrack )
{
    static char Msg[ 16 ];
    
    if ( CurrTrack != * OldTrack )
        {
        sprintf( Msg, "Piste:%02d", CurrTrack );
        TextOut( DeviceContext, 710, 544, Msg, strlen( Msg ) );
        * OldTrack = CurrTrack;
        }
}


/********************************************************* !NAME! **************
* Nom : AfficheInfos
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\\/FLE!, ligne : !./LN!
*
* Description : Affichage informations gnrales en bas de l'cran
*
* Rsultat    : /
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
void AfficheInfos( void )
{
    static char Cop1[] = "(C) 1996-2007 DEMONIAK (ldeplanque@nordnet.fr)                            ";
    static char Buffer[ MAX_PATH ];
    int OldTrack = -1;

    SetTextColor( DeviceContext, TEXT_COLOR );
    SetBkColor( DeviceContext, BK_COLOR );
    SelectObject( DeviceContext, f );
    TextOut( DeviceContext, 20, 544, Cop1, strlen( Cop1 ) );

#ifdef USE_NEWDISC
    if ( NewDiscOn )
        sprintf( Buffer, "Repertoire=%-80s", DirEmuDisc );
    else
#endif
        sprintf( Buffer, "Disquette=%-80s", NomDisc );

    TextOut( DeviceContext, 100, 556, Buffer, strlen( Buffer ) );
    SetLedFDC( 0 );
    AffichePiste( &OldTrack, GetCurrTrack() );
}


#ifdef USE_NEWDISC
/********************************************************* !NAME! **************
* Nom : ChoixRepertoire
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Ouvre une fentre de slection de rpertoire
*
* Rsultat    : TRUE si choix valid, FALSE sinon
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
static BOOL ChoixRepertoire( char * Rep )
{
    static char Buffer[ MAX_PATH ];
    BROWSEINFO bi;
    ITEMIDLIST * pidl;

    memset( &bi, 0, sizeof( bi ) );
    bi.ulFlags = BIF_RETURNONLYFSDIRS | BIF_STATUSTEXT | BIF_NEWDIALOGSTYLE;
    bi.hwndOwner = hWnd;
    pidl = SHBrowseForFolder( &bi );
    if ( pidl )
        {
        SHGetPathFromIDList( pidl, Buffer );
        strcpy( Rep, Buffer );
        return( TRUE );
        }
    return( FALSE );
}
#endif


/********************************************************* !NAME! **************
* Nom : TraceLigne32B640
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Trace une ligne cran de 768 points en couleurs 32 bits
*
* Rsultat    : /
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
static void TraceLigne32B640( int x, int y, int Adr, BOOL VBL )
{
    y <<= 1;
    x <<= 1;
    int * p = MemBitmap + x + ( TAILLE_Y_HIGH - y ) * TAILLE_X_HIGH;
    if ( VBL )
        memset( p, 0, 16 * sizeof( int ) );
    else
        {
        if ( Adr < 0 )
            for ( x = 0; x < 16; x++ )
                p[ x ] = TabCoul[ 16 ];
        else
            {
            int * ad = TabPoints[ LastMode ][ MemCPC[ Adr++ ] ];
            * p++ = TabCoul[ ad[ 0 ] ];
            * p++ = TabCoul[ ad[ 1 ] ];
            * p++ = TabCoul[ ad[ 2 ] ];
            * p++ = TabCoul[ ad[ 3 ] ];
            * p++ = TabCoul[ ad[ 4 ] ];
            * p++ = TabCoul[ ad[ 5 ] ];
            * p++ = TabCoul[ ad[ 6 ] ];
            * p++ = TabCoul[ ad[ 7 ] ];
            ad = TabPoints[ LastMode ][ MemCPC[ Adr ] ];
            * p++ = TabCoul[ ad[ 0 ] ];
            * p++ = TabCoul[ ad[ 1 ] ];
            * p++ = TabCoul[ ad[ 2 ] ];
            * p++ = TabCoul[ ad[ 3 ] ];
            * p++ = TabCoul[ ad[ 4 ] ];
            * p++ = TabCoul[ ad[ 5 ] ];
            * p++ = TabCoul[ ad[ 6 ] ];
            * p++ = TabCoul[ ad[ 7 ] ];
            p -= 16;
            }
        }
    if ( DoubleLines )
        memcpy( p + TAILLE_X_HIGH, p, 64 );
}


/********************************************************* !NAME! **************
* Nom : TraceLigne32B320
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Trace une ligne cran de 384 points en couleurs 32 bits
*
* Rsultat    : /
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
static void TraceLigne32B320( int x, int y, int Adr, BOOL VBL )
{
    int * p = MemBitmap + x + ( TAILLE_Y_HIGH - y ) * TAILLE_X_HIGH;
    if ( VBL )
        memset( p, 0, 8 * sizeof( int ) );
    else
        {
        if ( Adr < 0 )
            for ( x = 0; x < 8; x++ )
                p[ x ] = TabCoul[ 16 ];
        else
            {
            int * ad = TabPoints[ LastMode ][ MemCPC[ Adr++ ] ];
            * p++ = ( TabCoul[ ad[ 0 ] ] + TabCoul[ ad[ 1 ] ] ) >> 1;
            * p++ = ( TabCoul[ ad[ 2 ] ] + TabCoul[ ad[ 3 ] ] ) >> 1;
            * p++ = ( TabCoul[ ad[ 4 ] ] + TabCoul[ ad[ 5 ] ] ) >> 1;
            * p++ = ( TabCoul[ ad[ 6 ] ] + TabCoul[ ad[ 7 ] ] ) >> 1;
            ad = TabPoints[ LastMode ][ MemCPC[ Adr ] ];
            * p++ = ( TabCoul[ ad[ 0 ] ] + TabCoul[ ad[ 1 ] ] ) >> 1;
            * p++ = ( TabCoul[ ad[ 2 ] ] + TabCoul[ ad[ 3 ] ] ) >> 1;
            * p++ = ( TabCoul[ ad[ 4 ] ] + TabCoul[ ad[ 5 ] ] ) >> 1;
            * p = ( TabCoul[ ad[ 6 ] ] + TabCoul[ ad[ 7 ] ] ) >> 1;
            }
        }
}


#ifdef USE_DIRECTX
/********************************************************* !NAME! **************
* Nom : FctListeModes
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Liste les modes plein cran disponnibles
*
* Rsultat    : DDENUMRET_OK si ok, DDENUMRET_CANCEL sinon
*
* Variables globales modifies : TabModes, NbModes
*
********************************************************** !0! ****************/
static HRESULT CALLBACK FctListeModes( LPDDSURFACEDESC pddsd, LPVOID lpContext )
{
    TabModes[ NbModes ].TailleX = pddsd->dwWidth;
    TabModes[ NbModes ].TailleY = pddsd->dwHeight;
    TabModes[ NbModes ].Depth = pddsd->ddpfPixelFormat.dwRGBBitCount;
    NbModes++;
    if ( NbModes == D3DAPP_MAXMODES )
        return( DDENUMRET_CANCEL );

    return( DDENUMRET_OK );
}


/********************************************************* !NAME! **************
* Nom : CompareModes
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Fonction de comparaison de deux modes plein cran
*
* Rsultat    : Rsultat de la comparaison
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
static int _cdecl CompareModes( const void * element1, const void * element2 )
{
    StMode * Mode1 = ( StMode * )element1;
    StMode * Mode2 = ( StMode * )element2;

    int a = Mode1->TailleY - Mode2->TailleY;
    if ( a )
        return( a );

    a = Mode1->TailleX - Mode2->TailleX;
    if ( a )
        return( a );

    return( Mode1->Depth - Mode2->Depth );
}


/********************************************************* !NAME! **************
* Nom : SetDirectXDisplayMode
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Positionne le mode plein cran DirectX le plus proche de
*               la rsolution souhaite.
*
* Rsultat    : TRUE si initialisation OK, FALSE sinon
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
static BOOL SetDirectXDisplayMode( int TailleX, int TailleY )
{
    //
    // Rcuprer la liste des modes plein cran disponnibles et tri par
    // ordre croissant (rso X, rso Y puis profondeur)
    //
    NbModes = 0;
    lpDD->EnumDisplayModes( 0, NULL, NULL, FctListeModes );
    qsort( TabModes, NbModes, sizeof( StMode ), CompareModes );

    //
    // Rechercher le mode le plus appropri
    //
    for ( int i = 0; i < NbModes; i++ )
        if (  TabModes[ i ].TailleX >= TailleX
           && TabModes[ i ].TailleY >= TailleY
           && TabModes[ i ].Depth == 32
           )
            break;

    if ( lpDD->SetDisplayMode( TabModes[ i ].TailleX
                             , TabModes[ i ].TailleY
                             , TabModes[ i ].Depth
                             ) == DD_OK
       )
        return( TRUE );

    return( FALSE );
}


/********************************************************* !NAME! **************
* Nom : InitDirectX
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Initialisation cran DirectX
*
* Rsultat    : TRUE si initialisation OK, FALSE sinon
*
* Variables globales modifies : lpDD, lpDDSPrimary, NbModes
*
********************************************************** !0! ****************/
static BOOL InitDirectX( HWND hwnd, int TailleX, int TailleY )
{
    DDSURFACEDESC ddsd;

    if ( lpDD->SetCooperativeLevel( hwnd
                                  , DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN
                                  ) == DD_OK
       )
        {

        ddsd.dwSize = sizeof( ddsd );
        ddsd.dwFlags = DDSD_CAPS;
        ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
        ddsd.dwBackBufferCount = 1;
        if ( lpDD->CreateSurface( &ddsd
                                , &lpDDSPrimary
                                , NULL
                                ) == DD_OK
           )
            {
            if ( SetDirectXDisplayMode( TailleX, TailleY ) )
                return( lpDDSPrimary->GetDC( &DeviceContext ) == DD_OK );
            }
        }
    return( FALSE );
}


/********************************************************* !NAME! **************
* Nom : ReleaseDirectX
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Fermeture cran DirectX
*
* Rsultat    : /
*
* Variables globales modifies : lpDD, lpDDSPrimary
*
********************************************************** !0! ****************/
static void ReleaseDirectX( void )
{
    if( lpDDSPrimary != NULL )
        {
        lpDDSPrimary->ReleaseDC( DeviceContext );
        lpDDSPrimary->Release();
        lpDDSPrimary = NULL;
        }
}
#endif


/********************************************************* !NAME! **************
* Nom : SetScreenSize
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Positionne la taille de l'cran
*
* Rsultat    : TRUE
*
* Variables globales modifies : TailleWinX, TailleWinY, TailleFenX, TailleFenY,
*                                DrawFct
*
********************************************************** !0! ****************/
static BOOL SetScreenSize( void )
{
    static int TabX[ 4 ] = { 774, 390, 768, 384 };
    static int TabY[ 4 ] = { 596, 297, 544, 272 };

#ifdef USE_DIRECTX
    if ( BorderLess )
        {
        TailleWinX = /*SmallScreen ? TailleFenX >> 1 :*/ TailleFenX;
        TailleWinY = /*SmallScreen ? TailleFenY >> 1 :*/ TailleFenY;
        SmallScreen = TailleWinY < 300;
        }
    else
#endif
        {
#ifdef USE_DIRECTX
        TailleWinX = TabX[ SmallScreen + 2 * BorderLess ];
        TailleWinY = TabY[ SmallScreen + 2 * BorderLess ];
#else
        TailleWinX = TabX[ SmallScreen ];
        TailleWinY = TabY[ SmallScreen ];
#endif
        TailleFenX = SmallScreen ? TAILLE_X_LOW : TAILLE_X_HIGH;
        TailleFenY = SmallScreen ? TAILLE_Y_LOW : TAILLE_Y_HIGH;
        }

    DrawFct = SmallScreen ? TraceLigne32B320 : TraceLigne32B640;

    SetWindowPos( hWnd
                , HWND_TOP
                , CW_USEDEFAULT
                , CW_USEDEFAULT
                , TailleWinX
                , TailleWinY
                , SWP_NOMOVE
                );
    memset( MemBitmap
          , 0
          , pbmi.bmiHeader.biWidth * pbmi.bmiHeader.biHeight * 4
          );
    if ( ! SmallScreen )
        AfficheInfos();

    return( TRUE );
}


/********************************************************* !NAME! **************
* Nom : TouchesFonctions
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Gestion des touches fonctions pendant l'mulation
*
* Rsultat    : /
*
* Variables globales modifies : DebugMode, Cont, Turbo, MultifaceEnable
*
********************************************************** !0! ****************/
void TouchesFonctions( int Shift, WPARAM wParam )
{
    static char * Nom;
    static char Tmp[ 256 ];
    static int NumBitmap = 0;
    static int Pos;

    switch( wParam )
        {
#ifdef USE_DESASM
        case 0x20 :
            Cont = 1;
            break;
#endif
        /* 
            Touche F1 :
            Fentre aide
            SHIFT F1 :
            ????
        */
        case 0x70 :
            if ( Shift )
                {
                }
            else
                {
                EndSound();
                Aide( hWnd );
                InitSound();
                }

            break;

        /*
            Touche F2 :
            Mode Turbo ON/OFF
            SHIFT F2 :
            Sauvegarde bitmap
        */
        case 0x71 :
            if ( Shift )
                {
#ifdef USE_SAVE_BMP
                wsprintf( Tmp, "CPC_%04d.BMP", NumBitmap++ );
                SauveBitmap( Tmp );
#endif
                }
            else
                {
                Turbo ^= 1;
#ifdef USE_LOG
                sprintf( Tmp, "Mode turbo = %s", Turbo ? "ON" : "OFF" );
                Log( MODULENAME, Tmp, LOG_INFO );
#endif
                }
            break;

        /*
            Touche F3 :
            Bp de la multiface
            SHIFT F3 :
            'Swap' de la taille d'affichage
        */
        case 0x72 :
            if ( Shift )
                {
#ifdef USE_DESASM
                DebugMode = 0;
                Cont = 1;
#endif
#ifdef USE_DIRECTX
                if ( ! BorderLess )
#endif
                    {
                    SmallScreen ^= 1;
                    SetScreenSize();
                    }
                }
#ifdef USE_MULTIFACE
            else
                if ( ! MultifaceEnable && Multiface )
                    {
#ifdef USE_LOG
                    Log( MODULENAME, "Appui BP Multiface", LOG_INFO );
#endif
                    MultifaceEnable = 1;
                    Z80_NMI();
                    WriteVGA( 0x89 );
                    }
#endif
            break;

        /*
            Touche F4 :
            Lecture fichier snapshot
            SHIFT F4 :
            Basculement mode Monochrome/Couleur
        */
        case 0x73 :
            if ( Shift )
                {
                Monochrome = ( Monochrome + 1 ) & 3;
                }
            else
                {
                Nom = OpenNewFile( "Snapshot files (*.SNA)\0*.SNA\0"
                                 , "*.SNA"
                                 , DirSnap
                                 , ""
                                 , FALSE
                                 );
                if ( * Nom )
                    LireSnap( Nom );
                }
            break;

        /*
            Touche F5 :
            Ecriture fichier snapshot
            SHIFT F5 :
            Sauvegarde YM
        */
        case 0x74 :
            if ( Shift )
                {
#ifdef USE_SAVE_YM
                if ( WriteYMStarted() )
                    WriteYMEnd( hWnd );
                else
                    {
                    Nom = OpenNewFile( "YM files (*.YM)\0*.YM\0"
                                     , "*.YM"
                                     , DirYMFile
                                     , ""
                                     , TRUE
                                     );
                    if ( * Nom )
                        WriteYMInit( hWnd, Nom );
                    }
#endif
                }
            else
                {
                Nom = OpenNewFile( "Snapshot files (*.SNA)\0*.SNA\0"
                                 , "*.SNA"
                                 , DirSnap
                                 , ""
                                 , TRUE
                                 );
                if ( * Nom )
                    SauveSnap( Nom );
                }
            break;

        /*
            Touche F6 :
            Passage en mode debug
            SHIFT F6 :
            ????
        */
        case 0x75 :
            if ( Shift )
                {
                ShowWindow( hWnd, SW_MINIMIZE );
                }
#ifdef USE_DESASM
            else
                if ( ! SmallScreen )
                    {
                    DebugMode ^= 1;
                    Cont = 1;
                    if ( ! DebugMode )
                        AfficheInfos();
                    }
#endif
            break;

        /*
            Touche F7 :
            Lecture fichier disquette (.DSK)
            SHIFT F7 :
            ????
        */
        case 0x76 :
            if ( Shift )
                {
                }
            else
                {
                Nom = OpenNewFile( "DSK files (*.DSK)\0*.DSK\0"
                                 , "*.DSK"
                                 , DirDisc
                                 , NomDisc
                                 , FALSE
                                 );
                if ( * Nom )
                    {
#ifdef USE_NEWDISC
                    NewDiscOn = FALSE;
#endif
#ifdef USE_LOG
                    sprintf( Tmp, "Chargement disquette : %s", Nom );
                    Log( "Plateform", Tmp, LOG_INFO );
#endif
                    strcpy( NomDisc, Nom );
                    EjectDiskUPD( hWnd );
                    SetDiskUPD( hWnd, Nom );
                    }
                AfficheInfos();
                }
            break;

        /*
            Touche F8 :
            Reset du CPC
            SHIFT F8 :
            ????
        */
        case 0x77 :
            if ( Shift )
                {
                }
            else
                {
                EndSound();
#ifdef USE_MULTIFACE
                MultifaceEnable = 0;
#endif
                WriteVGA( 0x88 );
                ResetZ80();
                Reset8912();
                ResetCRTC();
                ResetUPD();
                InitSound();
                }
            break;

        /*
            Touche F9 : 
            Lecture fichier cassette
            SHIFT F9 :
            Positionnement fichier cassette
        */
        case 0x78 :
            if ( Shift )
                {
#ifdef USE_TAPE
                EndSound();
                Pos = GetPosTapeIn();
                if ( Pos != -1 )
                    {
                    Pos = SetPosFileTape( Pos, hWnd );
                    if ( Pos > -1 )
                        SetPosTapeIn( Pos );
                    }
                InitSound();
#endif
                }
#ifdef USE_TAPE
            else
                {
                Nom = OpenNewFile( "WAV files (*.WAV)\0*.WAV\0"
                                 , "*.WAV"
                                 , DirTape
                                 , ""
                                 , FALSE
                                 );
                if ( * Nom )
                    {
#ifdef USE_LOG
                    sprintf( Tmp, "Lecture fichier cassette : %s", Nom );
                    Log( "Plateform", Tmp, LOG_INFO );
#endif
                    OpenTapRead( Nom );
                    }
                }
#endif
            break;

        /*
            Touche F11 :
            Ecriture fichier cassette
            SHIFT F11 :
            sauvegarde fichier AVI
        */  
        case 0x7A :
            if ( Shift )
                {
#ifdef USE_SAVE_AVI
                if ( WriteAviStarted() )
                    WriteAviEnd( hWnd );
                else
                    {
                    Nom = OpenNewFile( "AVI files (*.AVI)\0*.AVI\0"
                                     , "*.AVI"
                                     , DirAviFile
                                     , ""
                                     , TRUE
                                     );
                    if ( * Nom )
                        WriteAviInit( hWnd
                                    , Nom
                                    , SmallScreen ? TAILLE_X_LOW : TAILLE_X_HIGH
                                    , SmallScreen ? TAILLE_Y_LOW : TAILLE_Y_HIGH
                                    );
                    }
#endif
                }
#ifdef USE_TAPE
            else
                {
                Nom = OpenNewFile( "WAV files (*.WAV)\0*.WAV\0"
                                 , "*.WAV"
                                 , DirTape
                                 , ""
                                 , TRUE
                                 );
                if ( * Nom )
                    {
#ifdef USE_LOG
                    sprintf( Tmp, "Ecriture fichier cassette : %s", Nom );
                    Log( "Plateform", Tmp, LOG_INFO );
#endif
                    OpenTapWrite( Nom );
                    }
                }
#endif
            break;

        /*
            Touche F12 :
            Lecture fichier direct
            SHIFT F12:
            ????
        */
        case 0x7B :
            if ( Shift )
                {
                }
#ifdef USE_NEWDISC
            else
                {
                FlushCloseIn();
                FlushCloseOut();
                NewDiscOn = ChoixRepertoire( DirEmuDisc );
                AfficheInfos();
                }
#endif
            break;
        }
}


/********************************************************* !NAME! **************
* Nom : OpenNewFile
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Ouverture d'une boite de dialogue de slection de nom de fichier
*
* Rsultat    : Le nom du fichier choisi
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
char * OpenNewFile( char * Filtre
                  , char * Ext
                  , char * Dir
                  , char * OldName
                  , BOOL Save
                  )
{
    static char NomFic[ 256 ];
    OPENFILENAME ofn;
    BOOL ret;
    char * p;

    p = strchr( Dir + 1, '.' );
    strcpy( NomFic, OldName );
    if ( p )
        {
        while( * p && * p != '\\' )
            * p-- = 0;
        }
    memset( &ofn, 0, sizeof( ofn ) );
    ofn.lStructSize = sizeof( OPENFILENAME );
    ofn.hwndOwner = hWnd;
    ofn.lpstrFilter = Filtre;
    ofn.nFilterIndex = 1L;
    ofn.lpstrFile = ( LPTSTR )NomFic;
    ofn.nMaxFile = sizeof( NomFic );
    ofn.lpstrInitialDir = Dir;
    ofn.lpstrDefExt = Ext;
    ofn.Flags = OFN_PATHMUSTEXIST;

    EndSound();
    if ( Save )
        {
        ofn.Flags |= OFN_OVERWRITEPROMPT;
        ret = GetSaveFileName( &ofn );
        }
    else
        {
        ofn.Flags |= OFN_FILEMUSTEXIST;
        ret = GetOpenFileName( &ofn );
        }
    if ( ret )
        strcpy( Dir, ofn.lpstrFile );

    InitSound();
    return( NomFic );
}


/********************************************************* !NAME! **************
* Nom : InitPlateforme
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Initialisation diverses
*
* Rsultat    : /
*
* Variables globales modifies : JoyKey, clav
*
********************************************************** !0! ****************/
void InitPlateforme( void )
{
    CalcPoints();
    memset( clav, 0xFF, sizeof( clav ) );
    if ( ! SmallScreen )
        AfficheInfos();
}


/********************************************************* !NAME! **************
* Nom : Erreur
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Affichage d'un message d'erreur
*
* Rsultat    : /
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
void Erreur( char * Msg )
{
    MessageBox( hWnd, Msg, "Emulateur CPC - Erreur", MB_ICONWARNING );
}


/********************************************************* !NAME! **************
* Nom : Info
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Affichage d'un message d'information
*
* Rsultat    : /
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
void Info( char * Msg )
{
    MessageBox( hWnd, Msg, "Emulateur CPC - Information", MB_ICONINFORMATION );
}


/********************************************************* !NAME! **************
* Nom : UpdateScreen
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Affiche l'cran du CPC
*
* Rsultat    : /
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
void UpdateScreen( void )
{
    int xSrc = SmallScreen ? TAILLE_X_LOW : TAILLE_X_HIGH;
    int ySrc = SmallScreen ? TAILLE_Y_LOW : TAILLE_Y_HIGH;

    if ( xSrc == TailleFenX && ySrc == TailleFenY )
        {
        BitBlt( DeviceContext, 0, 0, xSrc, ySrc
              , DcBitmap, 0, 0
              , SRCCOPY
              );
        }
    else
        StretchBlt( DeviceContext, 0, 0, TailleFenX, TailleFenY
                  , DcBitmap, 0, 0, xSrc, ySrc
                  , SRCCOPY
                  );
}


/********************************************************* !NAME! **************
* Nom : WndProc
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Gestion des messages de Windows
*
* Rsultat    : /
*
* Variables globales modifies : finMain, clav
*
********************************************************** !0! ****************/
LRESULT CALLBACK WndProc( HWND hWnd
                        , UINT message
                        , WPARAM wParam
                        , LPARAM lParam
                        )
{
    static int Shift = 0;

    switch( message )
        {
        case WM_PAINT :
            if ( ! SmallScreen )
                AfficheInfos();

            break;

        case WM_ACTIVATEAPP :
#ifdef USE_DIRECTX
            if ( BorderLess )
                {
                if ( wParam )
                    {
                    InitDirectX( hWnd, TailleWinX, TailleWinY );
                    AfficheInfos();
                    }
                else
                    ReleaseDirectX();
                }
#endif
            break;

        case WM_DESTROY :
        case WM_CLOSE :
            finMain = 1;

            break;

        case WM_KEYUP :
#ifdef USE_SENDKEYS
            if ( ClavFree )
#endif
                {
                if ( wParam == 0x10 )
                    Shift = 0;

                TouchesFonctions( Shift, wParam );
                clav[ TrKey[ wParam ].Ligne ] |= ~TrKey[ wParam ].Port;
                }
            break;

        case WM_KEYDOWN :
#ifdef USE_SENDKEYS
            if ( ClavFree )
#endif
                {
                if ( wParam == 0x10 )
                    Shift = 1;

#ifdef USE_DESASM
                if ( wParam == 0x0D )
                    Cont = 1;
#endif
                clav[ TrKey[ wParam ].Ligne ] &= TrKey[ wParam ].Port;
                }
            break;
        }

    return( DefWindowProc( hWnd, message, wParam, lParam ) );
}


/********************************************************* !NAME! **************
* Nom : CreateBitmapCPC
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Cration du bitmap contenant l'image cran du CPC
*
* Rsultat    : TRUE si ok, FALSE sinon
*
* Variables globales modifies : MemBitmap
*
********************************************************** !0! ****************/
static BOOL CreateBitmapCPC( HDC dc )
{
    pbmi.bmiHeader.biSize = sizeof( BITMAPINFOHEADER );
    pbmi.bmiHeader.biWidth = TAILLE_X_HIGH;
    pbmi.bmiHeader.biHeight = TAILLE_Y_HIGH;
    pbmi.bmiHeader.biPlanes = 1;
    pbmi.bmiHeader.biBitCount = 32;
    pbmi.bmiHeader.biCompression = BI_RGB;
    pbmi.bmiHeader.biSizeImage = 0;
    pbmi.bmiHeader.biXPelsPerMeter = 0;
    pbmi.bmiHeader.biYPelsPerMeter = 0;
    pbmi.bmiHeader.biClrUsed = 0;
    pbmi.bmiHeader.biClrImportant = 0;
    bm = CreateDIBSection( dc
                         , &pbmi
                         , DIB_RGB_COLORS
                         , ( void ** )&MemBitmap
                         , NULL
                         , 0
                         );
    if ( bm )
        {
        DcBitmap = CreateCompatibleDC( dc );
        if ( DcBitmap )
            {
            SelectObject( DcBitmap, bm );
            return( TRUE );
            }
        }
    return( FALSE );
}


/********************************************************* !NAME! **************
* Nom : ReleaseBitmap
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Libration des ressources alloues par la cration du du bitmap 
*               contenant l'image cran du CPC
*
* Rsultat    : /
*
* Variables globales modifies : DcBitmap, bm
*
********************************************************** !0! ****************/
static void ReleaseBitmap( void )
{
    if ( bm )
        {
        DeleteObject( bm );
        bm = NULL;
        }

    if ( DcBitmap )
        {
        DeleteDC( DcBitmap );
        DcBitmap = NULL;
        }
}


/********************************************************* !NAME! **************
* Nom : InitInstance
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Initialisation de l'instance du programme
*
* Rsultat    : TRUE si ok, FALSE sinon
*
* Variables globales modifies : hWnd, DeviceContext
*
********************************************************** !0! ****************/
BOOL InitInstance( HINSTANCE hInstance, int nCmdShow )
{
    WNDCLASSEX wcex;

    memset( &wcex, 0, sizeof( wcex ) );
    wcex.cbSize = sizeof( WNDCLASSEX ); 
    wcex.lpfnWndProc = ( WNDPROC )WndProc;
    wcex.hInstance = hInstance;
    wcex.hbrBackground = CreateSolidBrush( BK_COLOR );
    wcex.lpszClassName = TITRE;
    if ( RegisterClassEx( &wcex ) )
        {
        hInst = hInstance;

#ifdef USE_DIRECTX
        hWnd = CreateWindowEx( BorderLess ? WS_EX_CLIENTEDGE : 0
#else
        hWnd = CreateWindowEx( 0
#endif
                             , TITRE
                             , TITRE
#ifdef USE_DIRECTX
                             , BorderLess ? WS_POPUP : WS_SYSMENU | WS_MINIMIZEBOX
#else
                             , WS_SYSMENU | WS_MINIMIZEBOX
#endif
                             , CW_USEDEFAULT
                             , CW_USEDEFAULT
                             , TailleWinX
                             , TailleWinY
                             , NULL, NULL, hInstance, NULL
                             );
        if ( hWnd )
            {
#ifdef USE_DIRECTX
            if ( DirectDrawCreate( NULL, &lpDD, NULL ) == DD_OK )
#endif
                {
                DeviceContext = GetDC( hWnd );
                if ( CreateBitmapCPC( DeviceContext ) )
                    {
                    f = CreateFont( 14, 0, 0, 0, FW_DONTCARE, 0, 0, 0
                                  , OEM_CHARSET
                                  , OUT_DEFAULT_PRECIS
                                  , CLIP_DEFAULT_PRECIS
                                  , DEFAULT_QUALITY
                                  , FIXED_PITCH | FF_DONTCARE,NULL
                                  );
                    if ( f )
                        {
                        if ( SetScreenSize() )
                            {
                            //UpdateScreen();
                            SelectObject( DeviceContext, f );
                            //SetStretchBltMode( DcBitmap, COLORONCOLOR );
                            //SetStretchBltMode( DeviceContext, COLORONCOLOR );
                            ShowWindow( hWnd, nCmdShow );
                            //UpdateWindow( hWnd );
                            return( TRUE );
                            }
                        }
                    }
                }
            }
        }
    return( FALSE );
}


/********************************************************* !NAME! **************
* Nom : ReleaseResources
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Libration des ressources alloues
*
* Rsultat    : /
*
* Variables globales modifies : /
*
********************************************************** !0! ****************/
void ReleaseResources( void )
{
    ReleaseBitmap();
    if ( DeviceContext )
        ReleaseDC( hWnd, DeviceContext );

    if ( f )
        DeleteObject( f );

#ifdef USE_DIRECTX
    if( lpDD != NULL )
        {
        lpDD->Release();
        lpDD = NULL;
        }
#endif
}


/********************************************************* !NAME! **************
* Nom : TestJoy
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Lecture joystick et affectation si mouvement
*
* Rsultat    : /
*
* Variables globales modifies : clav
*
********************************************************** !0! ****************/
void TestJoy( void )
{
    static char OldDeltaX = 0, OldDeltaY = 0;
    static unsigned int OldButtons = 0;

    JOYINFOEX joyInfoEx;

    joyInfoEx.dwSize = sizeof( joyInfoEx );
    joyInfoEx.dwFlags = JOY_RETURNALL;

    // Test Joystick 1
    if ( joyGetPosEx( JOYSTICKID1, &joyInfoEx ) == JOYERR_NOERROR )
        {
        char DeltaX = ( char )( ( joyInfoEx.dwXpos - 0x7800 ) >> 13 );
        char DeltaY = ( char )( ( joyInfoEx.dwYpos - 0x7800 ) >> 13 );

        stToucheClav * Key = StTabRedirectJoy;
        if ( OldDeltaY != DeltaY )
            {
            // Up
            if ( DeltaY < 0 )
                clav[ Key->Ligne ] &= Key->Port;
            else
                clav[ Key->Ligne ] |= ~Key->Port;

            Key++;
            // Down
            if ( DeltaY > 0 )
                clav[ Key->Ligne ] &= Key->Port;
            else
                clav[ Key->Ligne ] |= ~Key->Port;
            }
        else
            Key++;

        Key++;
        if ( OldDeltaX != DeltaX )
            {
            // Left
            if ( DeltaX < 0 )
                clav[ Key->Ligne ] &= Key->Port;
            else
                clav[ Key->Ligne ] |= ~Key->Port;

            Key++;
            // Right
            if ( DeltaX > 0 )
                clav[ Key->Ligne ] &= Key->Port;
            else
                clav[ Key->Ligne ] |= ~Key->Port;
            }
        else
            Key++;

        if ( OldButtons != joyInfoEx.dwButtons )
            {
            // Boutons de 1  10
            for ( int b = 0; b < 10; b++ )
                {
                Key++;
                if ( joyInfoEx.dwButtons & ( 1 << b ) )
                    clav[ Key->Ligne ] &= Key->Port;
                else
                    clav[ Key->Ligne ] |= ~Key->Port;
                }
            }
        OldDeltaX = DeltaX;
        OldDeltaY = DeltaY;
        OldButtons = joyInfoEx.dwButtons; 
        }

    // Test Joystick 2
    if ( joyGetPosEx( JOYSTICKID2, &joyInfoEx ) == JOYERR_NOERROR )
        {
        clav[ 6 ] &= 0x80;
        clav[ 6 ] |= ( 0xF | ( ( ~joyInfoEx.dwButtons & 7 ) << 4 ) );
        char DeltaX = ( char )( ( joyInfoEx.dwXpos - 0x7800 ) >> 13 );
        char DeltaY = ( char )( ( joyInfoEx.dwYpos - 0x7800 ) >> 13 );
        if ( DeltaX > 0 )
            clav[ 6 ] &= 0xF7;
        else
            if ( DeltaX < 0 )
                clav[ 6 ] &= 0xFB;

        if ( DeltaY > 0 )
            clav[ 6 ] &= 0xFD;
        else
            if ( DeltaY < 0 )
                clav[ 6 ] &= 0xFE;
        }
}
