/******************************************************************************/
/* Configuration pour l'archivage des diffrents lments du fichier source   */
/******************************************************************************/
// !CONFIG!=/L/* /R/* /W"* Nom : "
// Dfinition du systme       !CONFIG!=/V1!EMULATEUR CPC!
// Dfinition du sous systme  !CONFIG!=/V2!PC-CPC!
// Dfinition du sous ensemble !CONFIG!=/V3!Noyau!
// Dfinition du module        !CONFIG!=/V4!Ecran Clavier!
/******************************************************************************/

/********************************************************* !NAME! **************
* !./FLE!
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\Fichiers
********************************************************** !0! *****************
* ------------------------------------------------------------------------------
*  Fichier     : PLATEFORM.H           | Version : 0.1al
* ------------------------------------------------------------------------------
*  Date        : 05/11/2002            | Auteur  : L.DEPLANQUE
* ------------------------------------------------------------------------------
*  Description : Dfinitions pour le module PLATEFORM.C
*
* ------------------------------------------------------------------------------
*  Historique  :
*           Date           |         Auteur          |       Description
* ------------------------------------------------------------------------------
*  05/11/2002              | L.DEPLANQUE             | creation
* ------------------------------------------------------------------------------
*  07/02/2006              | L.DEPLANQUE             | Version 0.1ak:
*                          |                         | Modification prototypes
*                          |                         | des fonctions de trac
*                          |                         | de lignes
* ------------------------------------------------------------------------------
*  21/07/2006              | L.DEPLANQUE             | Version 0.1al:
*                          |                         | Modification chaine de
*                          |                         | version
* ------------------------------------------------------------------------------
********************************************************** !END! **************/


#ifndef PLATEFORM_H
#define PLATEFORM_H


#include  <windows.h>


//
// Version
//
#define     VERSION         "0.1an bta"

#define     TITRE           "PC-CPC - Version " VERSION " (Build " __DATE__ ")"


//
// Tailles affichage cran suivant la rsolution voulue
//
#define     TAILLE_X_LOW    384
#define     TAILLE_Y_LOW    272

#define     TAILLE_X_HIGH   768
#define     TAILLE_Y_HIGH   544


//
// Couleurs textes et fond
//
#define     TEXT_COLOR      RGB( 0xFF, 0xFF, 0xFF )
#define     BK_COLOR        RGB( 0x10, 0x10, 0x10 )


typedef void ( * pfctDraw )( int, int, int, BOOL );


/********************************************************* !NAME! **************
* Nom : stToucheClav
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Structures
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Structure clavier CPC
*
********************************************************** !0! ****************/
typedef struct
    {
    UBYTE Port;
    UBYTE Ligne;
    } stToucheClav;


extern int LastMode;

extern int DebugMode, Cont;

extern HWND hWnd;

extern HDC DeviceContext;

extern int Turbo;

extern int Monochrome;

extern pfctDraw DrawFct;

extern int * MemBitmap;

extern BITMAPINFO pbmi;

extern char NomDisc[ MAX_PATH ];

extern BOOL ClavFree;


BOOL InitInstance( HINSTANCE hInstance, int nCmdShow );

void TouchesFonctions( int Shift, WPARAM wParam );

char * OpenNewFile( char * Filtre
                  , char * Ext
                  , char * Dir
                  , char * OldName
                  , BOOL Save
                  );

void Erreur( char * Msg );

void Info( char * Msg );

void AfficheInfos( void );

void AffichePiste( int * OldTrack, int CurrTrack );

void InitPlateforme( void );

void ReleaseResources( void );

void UpdateScreen( void );

void TestJoy( void );

void SetLedFDC( int Etat );


#endif
