/******************************************************************************/
/* Configuration pour l'archivage des diffrents lments du fichier source   */
/******************************************************************************/
// !CONFIG!=/L/* /R/* /W"* Nom : "
// Dfinition du systme       !CONFIG!=/V1!EMULATEUR CPC!
// Dfinition du sous systme  !CONFIG!=/V2!PC-CPC!
// Dfinition du sous ensemble !CONFIG!=/V3!Chips!
// Dfinition du module        !CONFIG!=/V4!PPI 8255!
/******************************************************************************/

/********************************************************* !NAME! **************
* !./FLE!
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\Fichiers
********************************************************** !0! *****************
* ------------------------------------------------------------------------------
*  Fichier     : PPI.H                 | Version : 0.1am
* ------------------------------------------------------------------------------
*  Date        : 05/11/2002            | Auteur  : L.DEPLANQUE
* ------------------------------------------------------------------------------
*  Description : Dfinitions pour le module PPI.C
*
* ------------------------------------------------------------------------------
*  Historique  :
*           Date           |         Auteur          |       Description
* ------------------------------------------------------------------------------
*  05/11/2002              | L.DEPLANQUE             | creation
* ------------------------------------------------------------------------------
*  07/11/2002              | L.DEPLANQUE             | Ajout gestion lecture et
*                          |                         | criture cassette.:
*                          |                         | fonctions WriteCas() et
*                          |                         | ReadCas().
* ------------------------------------------------------------------------------
*  06/12/2006              | L.DEPLANQUE             | Version 0.1am :
*                          |                         | Variable "VBL" remplace
*                          |                         | par "VSync" et dplace
*                          |                         | dans le module CRTC
* ------------------------------------------------------------------------------
********************************************************** !END! **************/


#ifndef PPI_H
#define PPI_H


typedef struct
    {
    char    Tag1[ 4 ];
    int     Size1;
    char    Tag2[ 14 ];
    short   Mode;
    int     Freq;
    int     BytePerSec;
    short   NbBytes;
    short   Format;
    char    Tag3[ 4 ];
    int     Size2;
    } StWave;


extern int clav[ 16 ];

extern int RegsPPI[ 4 ];

extern int RegPSGSel;

extern int TpsTapeIn;

extern int TpsTapeOut;

void WritePPI( int adr, int val );

int ReadPPI( int adr );

void WriteCas( void );

void ReadCas( void );

void OpenTapWrite( char * Nom );

void OpenTapRead( char * Nom );

void CloseTapIn( void );

void CloseTapOut( void );

void SetPosTapeIn( int Pos );

int GetPosTapeIn( void );


#endif


