/******************************************************************************/
/* Configuration pour l'archivage des diffrents lments du fichier source   */
/******************************************************************************/
// !CONFIG!=/L/* /R/* /W"* Nom : "
// Dfinition du systme       !CONFIG!=/V1!EMULATEUR CPC!
// Dfinition du sous systme  !CONFIG!=/V2!PC-CPC!
// Dfinition du sous ensemble !CONFIG!=/V3!Accessoires!
// Dfinition du module        !CONFIG!=/V4!SauveBmp!
/******************************************************************************/

/********************************************************* !NAME! **************
* !./FLE!
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\Fichiers
********************************************************** !0! *****************
* ------------------------------------------------------------------------------
*          SYSTEME         |      SOUS SYSTEME       |      SOUS ENSEMBLE
* ------------------------------------------------------------------------------
*  EMULATEUR CPC           | PC-CPC                  | Accessoires
* ------------------------------------------------------------------------------
*  Fichier     : SAUVEBMP.C            | Version : 0.1ai
* ------------------------------------------------------------------------------
*  Date        : 30/11/2005            | Auteur  : L.DEPLANQUE
* ------------------------------------------------------------------------------
*  Description : Ecriture d'un fichier bmp contenant l'cran de l'mulateur
*
* ------------------------------------------------------------------------------
*  Historique  :
*           Date           |         Auteur          |       Description
* ------------------------------------------------------------------------------
*  30/11/2005              | L.DEPLANQUE             | creation
* ------------------------------------------------------------------------------
*  08/12/2005              | L.DEPLANQUE             | Version 0.1ai:
*                          |                         | prise en compte
*                          |                         | paramtres bitmap pour
*                          |                         | sauvegarde BMP sous
*                          |                         | plusieurs formats
* ------------------------------------------------------------------------------
********************************************************** !END! **************/


#include  <windows.h>
#include  <wingdi.h>
#include  <stdio.h>

#include  "Types.h"
#include  "Plateform.h"
#include  "Vga.h"
#include  "Log.h"


#define     MODULENAME      "SauveBmp"


#ifdef USE_SAVE_BMP

/********************************************************* !NAME! **************
* Nom : SauveBitmap
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Fonctions
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\\/FLE!, ligne : !./LN!
*
* Description : Ecrit une image au format BMP
*
* Rsultat    : 
*
* Variables globales modifies : 
*
********************************************************** !0! ****************/
void SauveBitmap( char * NomFic )
{
    BITMAPFILEHEADER bmHeader;
    int Depth = pbmi.bmiHeader.biBitCount;
    int Size = pbmi.bmiHeader.biWidth * pbmi.bmiHeader.biHeight * ( Depth >> 3 );
    FILE * fp;

    memset( &bmHeader, 0, sizeof( bmHeader ) );
    bmHeader.bfType = * ( WORD * )"BM";
    bmHeader.bfOffBits = sizeof( bmHeader ) + sizeof( BITMAPINFOHEADER );
    bmHeader.bfSize = pbmi.bmiHeader.biSizeImage + bmHeader.bfOffBits;
    fp = fopen( NomFic, "wb" );
    if ( fp )
        {
        fwrite( &bmHeader, sizeof( bmHeader ), 1, fp );
        fwrite( &pbmi.bmiHeader, sizeof( pbmi.bmiHeader ), 1, fp );
        fwrite( MemBitmap, Size, 1, fp );
        fclose( fp );
        }
    else
        {
        sprintf( MsgLog, "Impossible de crer le fichier %s.", NomFic );
#ifdef USE_LOG
        Log( MODULENAME, MsgLog, LOG_WARNING );
#endif
        Erreur( MsgLog );
        }
}

#endif
