/******************************************************************************/
/* Configuration pour l'archivage des diffrents lments du fichier source   */
/******************************************************************************/
// !CONFIG!=/L/* /R/* /W"* Nom : "
// Dfinition du systme       !CONFIG!=/V1!EMULATEUR CPC!
// Dfinition du sous systme  !CONFIG!=/V2!PC-CPC!
// Dfinition du sous ensemble !CONFIG!=/V3!Noyau!
// Dfinition du module        !CONFIG!=/V4!Types!
/******************************************************************************/

/********************************************************* !NAME! **************
* !./FLE!
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\Fichiers
********************************************************** !0! *****************
* ------------------------------------------------------------------------------
*  Fichier     : TYPES.H               | Version : 0.1p
* ------------------------------------------------------------------------------
*  Date        : 05/11/2002            | Auteur  : L.DEPLANQUE
* ------------------------------------------------------------------------------
*  Description : Dfinitions de types prdfinis et de constantes de compilation
*
* ------------------------------------------------------------------------------
*  Historique  :
*           Date           |         Auteur          |       Description
* ------------------------------------------------------------------------------
*  05/11/2002              | L.DEPLANQUE             | creation
* ------------------------------------------------------------------------------
********************************************************** !END! **************/


#ifndef TYPES_H
#define TYPES_H


#pragma warning( disable : 4711 )


typedef unsigned short          USHORT;

typedef short                   SHORT;

typedef unsigned char           UBYTE;

typedef unsigned long           ULONG;

typedef int                     BOOL;


/********************************************************* !NAME! **************
* Nom : StAmsdos
********************************************************** !PATHS! *************
* !./V1!\!./V2!\!./V3!\!./V4!\Structures
********************************************************** !1! *****************
*
* Fichier     : !./FPTH\/FLE!, ligne : !./LN!
*
* Description : Structure de l'en-tte Amsdos avant les donnes des fichiers
*
********************************************************** !0! ****************/
typedef struct
    {
    UBYTE   UserNumber;             // User
    UBYTE   FileName[ 15 ];         // Nom + extension
    UBYTE   BlockNum;               // Numro du premier bloc (disquette)
    UBYTE   LastBlock;              // Numro du dernier bloc (disquette)
    UBYTE   FileType;               // Type de fichier
    USHORT  Length;                 // Longueur
    USHORT  Adress;                 // Adresse
    UBYTE   FirstBlock;             // Premier bloc de fichier (disquette)
    USHORT  LogicalLength;          // Longueur logique
    USHORT  EntryAdress;            // Point d'entre
    UBYTE   Unused[ 0x24 ];
    USHORT  RealLength;             // Longueur relle
    UBYTE   BigLength;              // Longueur relle (3 octets)
    USHORT  CheckSum;               // Checksum Amsdos
    UBYTE   Unused2[ 0x3B ];
    } StAmsdos;


#ifndef FALSE
enum { FALSE = 0, TRUE };
#endif


#ifdef _DEBUG
#define     USE_LOG
#endif


#define     USE_ROM_PACK

//#define     USE_PROFILE

#define     USE_NEWDISC

#define     USE_DESASM

#define     USE_MULTIFACE

#define     USE_PRINTER

#define     USE_SAVE_BMP

#define     USE_SAVE_AVI

#define     USE_SAVE_YM

#define     USE_TAPE

#define     USE_DIRECTX

#define     USE_SENDKEYS

#define     FAST_SOUND_UPDATE


#endif
